
/*+ --------------------------------------------------- + 
  +			iFBS				+
  +	Iterative First-Band Search Algorithms		+
  + --------------------------------------------------- +*/

#define	PRINT_GROWTH_PROFILE	printf \
("iter=%d, child_sp=%x, approx=%g, exp_opt(glub=%g)=%g, gllb=%g, bandwidth=%d, time=%d\n", \
iter, child_sp, child_sp->approx.approx, \
(float) child_sp->glub, (float) expected_opt(child_sp), \
(float) child_sp->gllb, \
child_sp->band.init_width, \
get_time(child_sp));


void ifbs_algorithm (sp)
  search_ *sp;
{ search_ *child_sp;
  search_message_ msg;
  search_ending_ term_signal; /** not important, only as a placeholder **/
  float bw;
  int iter = 0;
  int i;

  sp->approx.achieved = sp->approx.root_approx;
  sp->gllb = sp->root_lb;
  sp->glub = sp->root_ub;

  set_search_message (&msg, FRESH_START, NULL, YES, cmd.pf.rt, cmd.pf.st);
  child_sp = create_child_search (sp);
  child_sp->strategy = FBS;

  for (iter = 0; 1; iter++) {

    for (bw = 1.0, i = 1; i <= iter; i++) bw *= sp->band.growth_rate;
    child_sp->band.init_width = (int) bw;
    init_all_bandwidths (child_sp);

    put_child_constr (child_sp, sp, 1.0, 1.0, 1.0);

    idpd_init();
    msg.feasible = NO;
    term_signal = first_band_primitive (child_sp, sp, &msg);

    eval_final_approx (child_sp);
#ifdef DEBUG
if (cmd.debug >= 1) { PRINT_GROWTH_PROFILE }
#endif
    merge_stat_to_parent (child_sp, sp);
    merge_sol_to_parent (child_sp, sp);
    if (get_approx (child_sp) <= sp->approx.achieved)
      merge_approx_to_parent (child_sp, sp);
    /** merge_threshold_to_parent (child_sp, sp); **/

    if (get_time (sp) >= sp->constr.time) break;
    if (end_of_first_sol_search (sp) == YES) break;
    if (end_of_opt_sol_search (sp) == YES) break;

    (sp->child = child_sp = create_brother_search (child_sp))->parent = sp;
    child_sp->strategy = FBS;
  }
}

