
/* 		IRA*			*/

void ira_algorithm (sp)
  search_ *sp;
{ search_ *child_sp;
  search_message_ msg;
  search_ending_ term_signal;
  int iter;
  float a[4];

  a[0] = 0.2; a[1] = 0.1; a[2] = 0.05; a[3] = 0.0;

  sp->approx.achieved = sp->approx.root_approx;
  sp->gllb = sp->root_lb;
  sp->glub = sp->root_ub;

  set_search_message (&msg, FRESH_START, NULL, YES, cmd.pf.rt, cmd.pf.st);
  child_sp = create_child_search (sp);
  for (iter = 0; iter < 4; iter++) {
    inherit_sol_from_parent (child_sp, sp);
    child_sp->approx.approx = a[iter];
    idpd_init ();
    term_signal = (sp->strategy == DFS) ? dfs_primitive(child_sp, sp, &msg) :
					  gdfs_primitive(child_sp, sp, &msg);
    eval_final_approx(child_sp);
#ifdef DEBUG
if (cmd.debug >= 1)
  printf("iter=%d, approx(glub=%g)=%g, threshold=%g, time=%d\n",
	iter, (float) child_sp->glub, (float) expected_opt(child_sp),
        (float) child_sp->alg.urts->th, get_time(child_sp));
#endif
    merge_stat_to_parent (child_sp, sp);
    merge_sol_to_parent (child_sp, sp);
    if (get_approx (child_sp) <= sp->approx.achieved) {
      merge_approx_to_parent (child_sp, sp);
    }

    if (end_of_first_sol_search (sp) == YES) break;
    if (end_of_opt_sol_search (sp) == YES) break;

    (sp->child = child_sp = create_brother_search (child_sp))->parent = sp;
  }
}
