
void lawler_wood_algorithm (sp)
  search_ *sp;
{ constr_ save_constr;
  search_message_ msg;
  search_ending_ se;

  sp->approx.achieved = sp->approx.root_approx;
  save_constr = sp->constr;
  set_stop_constr (sp, 0.5, 0.5, 0.5);
  set_search_message (&msg, FRESH_START, NULL, NO, cmd.pf.rt, cmd.pf.st);

  while (1) {
    switch (sp->strategy) {
    case GBB:  se = gbb_primitive (sp, NULL, &msg); 		break;
    case BFS:  se = bfs_primitive (sp, NULL, &msg);		break;
    case DFS:  se = dfs_primitive (sp, NULL, &msg);		break;
    case GDFS: se = gdfs_primitive (sp, NULL, &msg);		break;
    case BAND: se = band_primitive (sp, NULL, &msg);		break;
    case FBS:  se = first_band_primitive (sp, NULL, &msg);	break;
    default:   error("search: no such strategy\n"); 	break;
    }

    if (se == SEARCH_IS_COMPLETED) break;
    if (is_lw_end (sp, &save_constr) == YES) break;
    msg.style = RESUME;
    sp->approx.approx += 0.05;
    lw_set_constr (sp, &save_constr);

    if (end_of_first_sol_search (sp) == YES) break;
    if (end_of_opt_sol_search (sp) == YES) break;

  } 

  sp->constr = save_constr;
  eval_final_approx (sp);
}


yesno_ is_lw_end (sp, constrp)
  search_ *sp;
  constr_ *constrp;
{
  if (sp->constr.time != huge_long)
    if (sp->constr.time >= constrp->time) return YES;
  if (sp->constr.space != huge_long)
    if (sp->constr.space >= constrp->space) return YES;
  if (sp->constr.cst != huge_float)
    if (sp->constr.cst >= constrp->cst) return YES;
  return NO;
}


void lw_set_constr (sp, constrp)
  search_ *sp;
  constr_ *constrp;
{ float time, space, cst;

  if (sp->constr.time != huge_long) {
    time = (float) (constrp->time - sp->constr.time);
    time = time * 0.5;
    if (time < 1.0) time = 1.0;
    sp->constr.time += tolong(time);
  }
  if (sp->constr.space != huge_long) {
    space = (float) (constrp->space - sp->constr.space);
    space = space * 0.5;
    if (space < 1.0) space = 1.0;
    sp->constr.space += tolong(space);
  }
  if (sp->constr.cst != huge_float) {
    cst = (constrp->cst - sp->constr.cst) * 0.5;
    if (cst < 1.0) cst = 1.0;
    sp->constr.cst += cst;
  }
}

