
#ifndef __wise_config_h_
#define __wise_config_h_

/* kernel/etc.c */
extern int 	ceiling(), is_any(), is_member(), is_invalid_gllb(),
		is_compound(), is_algo_rt_pf(), gen_random_int();
extern float 	gen_random_float(), gen_random_range();
extern solution_ *get_sol_buf();
extern void 	error(), set_compound(), free_sol_buf(), set_random_radix(),
     	    	set_search_task(), debug_node(), set_node_size(), junk();

/* kernel/free.c */
extern void	free_environ(), free_alg_struct(), free_open(), free_list(),
		free_btree(), free_stack(), free_node();
extern long	free_bptree ();

/* kernel/init.c */
extern node_	*create_root();
extern void	clear_files(), attach_alg_struct(), init_alg_struct(),
		examine_root();
extern search_	*init_environ();

/* kernel/limit.c */
extern int	is_constr_violated();
extern float	calc_rt_approx(), get_rt_approx(), get_approx();
extern domain 	expected_opt(), get_threshold();
extern yesno_	is_threshold_related();
extern void	eval_rt_approx(), put_achieved_approx(), eval_final_approx(),
		put_threshold(), merge_threshold_to_parent(),
		put_child_constr(), set_stop_constr();

/* kernel/para.c */
extern yesno_	para_termination ();
extern void	para_merge_solution (), para_merge_stat (), para_load_balancing ();
extern node_	*para_request ();

/* kernel/profile.c */
extern int	is_in_transient_phase();
extern void	pf_run_time(), pf_space_vs_time(), alg_rt_pf(), alg_pf(),
		alg_pf_predict();

/* kernel/search.c */
extern int	is_bounded(), is_hard_bounded();
extern search_	*create_brother_search(), *create_child_search();
extern void	search(), alg_entry(), alg_entry_aux (), default_search(),
		dominating(), bounding(), btree_bounding(), list_bounding(),
		bptree_bounding(), set_search_message();
extern yesno_	end_of_opt_sol_search (), end_of_first_sol_search ();

/* kernel/stat.c */
extern long	get_time(), get_space(), get_max_space(), get_pruned(),
		get_offset_time(), get_offset_space(), get_offset_max_space(),
		get_offset_gen();
extern float	get_cst(), get_offset_rt_approx(), get_offset_cst();
extern void	update_stat(), merge_stat_to_parent(), merge_approx_to_parent(),
		merge_sol_to_parent(), inherit_sol_from_parent();

/* include/var.c */
extern float	get_float_cmd_line_param(), get_float_cmd_line_auxparam();
extern void	init_env_struct(), init_problem_struct(), init_cmd_struct(),
		init_factor_struct(), init_io_struct(), init_stat_struct(),
		init_constr_struct(), init_profile_struct(),
		init_band_struct (), init_tree_struct (),
		init_all_bandwidths (), init_tcr_struct (),
		init_approx_struct(), init_search_struct(),
		init_regress_struct(), init_stca_struct(), init_ptca_struct(),
		init_dtca_struct(), init_stcgd_struct(), init_ptcgd_struct(),
		init_dtcgd_struct(), init_ida_struct(), init_node_struct(),
		init_set_th_struct(), create_th_bin(), init_urts_struct(),
		init_brts_struct(), init_hrts_struct();

/* primitve/bfs.c */
extern search_ending_ bfs_primitive();

/* primitve/gbb.c */
extern search_ending_ gbb_primitive();

/* primitive/dfs.c */
extern search_ending_ dfs_primitive();

/* primitive/gdfs.c */
extern search_ending_ gdfs_primitive();

/* primitive/band.c */
extern search_ending_ band_primitive();

/* primitive/first-band.c */
extern search_ending_ first_band_primitive();

/* primitive/path.c */
extern search_ending_ path_primitive();

/* primitive/first.c */
extern search_ending_ first_primitive();

/* algorithm/default.c */
extern void	default_algorithm();

/* algorithm/lw.c */
extern yesno_	is_lw_end();
extern void	lawler_wood_algorithm(), lw_set_constr();

/* algorithm/para.c */
extern void	para_algorithm ();
extern yesno_	para_primitive ();

/* algorithm/tca.c */
extern float	get_stca_next_approx();
extern void	stca_algorithm(), ptca_algorithm(), dtca_algorithm(),
		dtca_entry();

/* algorithm/tcgd.c */
extern float	get_stcgd_next_approx();
extern void	stcgd_algorithm(), ptcgd_algorithm();

/* algorithm/rts.c */
extern void	urts_algorithm(), urts_entry(),
		brts_algorithm(), brts_entry(),
		hrts_algorithm(), hrts_entry();

/* algorithm/ird.c */
extern void	uird_algorithm(), uird_entry(),
		bird_algorithm(), bird_entry();

/** algorithm/ifbs.c **/
extern void	ifbs_algorithm ();

/** open/bandlist.c **/
extern node_	*get_band_node (), *young_delete ();
extern void	put_band_node (), young_insert ();
extern int	is_young_empty ();

/* open/bptree.c */
extern int	is_bptree_empty();
extern node_	*bptree_delete();
extern void	bptree_insert();

/* open/btree.c */
extern int	is_btree_empty();
extern node_	*btree_delete();
extern void	btree_insert();

/* open/list.c */
extern int	is_list_empty();
extern node_	*list_delete();
extern void	list_insert();

/* open/pool.c */
extern node_	*get_search_node_from_pool();
extern void	dispose_search_node_to_pool();

/* open/sort.c */
extern int	is_open_empty();
extern node_	*delete();
extern domain	sort_key();
extern void	insert();

/* open/stack.c */
extern int	is_stack_empty();
extern node_	*stack_top(), *stack_bottom();
extern void	stack_push(), stack_pop();

/* interface/command.c */
extern void	cmd_line();

/* interface/output.c */
extern void	flush_accounting(), flush_summary(), flush_graph();

/* interface/result.c */
extern void	keep_result(), print_result();

#endif __wise_config_h_

