
void flush (sp)
  search_ *sp;
{
#ifdef OUT_GRAPH
  flush_graph(sp);
#endif
#ifdef OUT_SUMMARY
  flush_summary(sp);
#endif
}


void flush_summary (sp)
  search_ *sp;
{ FILE *fp;

  fp = fopen(io.summary, "w");
  fprintf(fp, "counting system=%s\n", (cmd.count == REAL) ? "real" : "virtual");

  if (sp->constr.time == huge_long) fprintf(fp, "time unlimited\n");
  else fprintf(fp, "time limit=%d\n", sp->constr.time);

  if (sp->constr.space == huge_long) fprintf(fp, "space unlimited\n");
  else fprintf(fp, "space limit=%d\n", sp->constr.space);

  if (sp->constr.cst == huge_float) fprintf(fp, "cst unlimited\n");
  else fprintf(fp, "cst limit=%g\n", sp->constr.cst);

  fprintf(fp, "real time=%d\n", sp->stat.time);
  fprintf(fp, "real max space=%g\n",
              ((float) (node_conf.node_size * sp->stat.max_active)));
  fprintf(fp, "real cst=%g\n", sp->stat.r_cst);

#ifdef TIME_IS_GEN
  fprintf(fp, "virtual time=%d\n", sp->stat.generated);
#else
  fprintf(fp, "virtual time=%d\n", sp->stat.expanded);
#endif
  fprintf(fp, "virtual max space=%d\n", sp->stat.max_active);
  fprintf(fp, "virtual cst=%g\n", sp->stat.v_cst);

  fprintf(fp, "root approx=%g\n", sp->approx.root_approx); 
  fprintf(fp, "run-time approx=%g\n", sp->approx.run_time); 

  if ((sp->approx.approx > 0.0) || (sp->approx.run_time > 0.0))
    fprintf(fp,"semi-");
  fprintf(fp, "optimal solution value=%g\n", tofloat(sp->glub));

  fprintf(fp, "cmd-line (or adapted) approx=%g\n", sp->approx.approx);
  fprintf(fp, "achieved approx=%g\n", sp->approx.achieved);
  fprintf(fp, "run-time approx=%g\n", sp->approx.run_time);
  fclose(fp);
}


void flush_graph (sp)
  search_ *sp;
{ FILE *fp;

  fp = fopen(io.graph,"a");

  if (OUT_TIME_LIMIT) fprintf(fp, "%d  ", sp->constr.time);
  if (OUT_SPACE_LIMIT) fprintf(fp, "%g  ", sp->constr.space);
  if (OUT_CST_LIMIT) fprintf(fp, "%g  ", sp->constr.cst);

  if (OUT_REAL_TIME) fprintf(fp, "%d  ", sp->stat.time);
  if (OUT_REAL_MAX_SPACE) fprintf(fp, "%g  ",
                       ((float) (node_conf.node_size * sp->stat.max_active)));
  if (OUT_REAL_CST) fprintf(fp, "%g  ", sp->stat.r_cst);

  if (OUT_VIRTUAL_TIME)
#ifdef TIME_IS_GEN
    if (cmd.num_pe <= 1) fprintf(fp, "%d  ", sp->stat.generated);
#else
    if (cmd.num_pe <= 1) fprintf(fp, "%d  ", sp->stat.expanded);
#endif
    else fprintf(fp, "%d  ", sp->stat.num_op);
  if (OUT_VIRTUAL_MAX_SPACE) fprintf(fp, "%d  ", sp->stat.max_active);
  if (OUT_VIRTUAL_CST) fprintf(fp, "%g  ", sp->stat.v_cst);

  if (OUT_ROOT_APPROX) fprintf(fp, "%g  ", sp->approx.root_approx);
  if (OUT_RUN_TIME_APPROX) fprintf(fp, "%g  ", sp->approx.run_time);
  if (OUT_APPROX) fprintf(fp, "%g  ", sp->approx.achieved);
  if (OUT_INCUMBENT) fprintf(fp, "%g  ", tofloat(sp->glub));
  if (OUT_LOWB) fprintf(fp, "%g  ", tofloat(sp->gllb));
  if (OUT_THRESHOLD) fprintf(fp, "%g  ", tofloat(sp->constr.bound));

#ifdef MEASURE_PHYSICAL_TIME
  fprintf(fp, "%g  ", tofloat(sp->stat.unix_utime));
#endif

  switch (sp->algorithm) {
    case sTCA:
      if (OUT_GRADIENT_FACTOR) fprintf(fp, "%g  ", sp->alg.stca->g_factor);
      break;
    case sTCGD:
      if (OUT_GRADIENT_FACTOR) fprintf(fp, "%g  ", sp->alg.stcgd->g_factor);
      break;
    case pTCA:
      if (OUT_STOPPING_FACTOR) fprintf(fp, "%g  ", sp->alg.ptca->s_factor);
      if (OUT_CORRECTIVE_FACTOR) fprintf(fp, "%g  ", sp->alg.ptca->c_factor);
      break;
    case dTCA:
      if (OUT_STOPPING_FACTOR) fprintf(fp, "%g  ", sp->alg.dtca->s_factor);
      if (OUT_CORRECTIVE_FACTOR) fprintf(fp, "%g  ", sp->alg.dtca->c_factor);
      break;
    case pTCGD:
      if (OUT_STOPPING_FACTOR) fprintf(fp, "%g  ", sp->alg.ptcgd->s_factor);
      if (OUT_CORRECTIVE_FACTOR) fprintf(fp, "%g  ", sp->alg.ptcgd->c_factor);
      break;
    default: break;
  }
  fprintf(fp, "\n");  fclose(fp);
}

