
void error (msg)
  char *msg;
{ fprintf(stderr, "*** ERROR ***  %s", msg); exit(0); }


int ceiling (val)
  float val;
{ int temp;

  temp = toint(val);
  if (val > tofloat(temp)) temp++;
  return temp;
}


int is_any (array, left, right)
  int array[], left, right;
{ int k;

  for (k = left; k <= right; k++)
    if (array[k]) return 1;
  return 0;
}


int is_member (item, array, left, right)
  int item, array[], left, right;
{ int i;

  for (i = left; i < right; i++)
    if (item == array[i]) return 1;
  return 0;
}


int is_invalid_gllb (sp)
  search_ *sp;
{ return ((tofloat(sp->gllb) == 0.0) || (sp->gllb == - problem.huge)); }


int is_compound (n)
  node_ *n;
{ return (n->type == ACTIVE_COMPOUND); }


void set_compound (n)
  node_ *n;
{ n->type = ACTIVE_COMPOUND; }


/* internal maintenance of solution buffers */
solution_	*sol_buf_mgr = NULL;

solution_ *get_sol_buf ()
{ solution_ *p;

  if (sol_buf_mgr) {
    p = sol_buf_mgr;
    sol_buf_mgr = ((solution_ *) *((int *) p));
  }
  else {
    p = (solution_ *) malloc(2 * sizeof(solution_));
    sol_buf_mgr = p + 1;
    *((int *) sol_buf_mgr) = NULL;
  }
  reset_sol_buf(p);
  return p;
}


void free_sol_buf (solp)
  solution_ *solp;
{ 
  *((int *) solp) = ((int) sol_buf_mgr);
  sol_buf_mgr = solp;
}


int is_alg_rt_pf (sp)
  search_ *sp;
{
  switch(sp->algorithm) {
    case pTCA:
    case dTCA: return 1;
    default:   return 0;
  }
}


/* generate a random integer over [left,right] */
int gen_random_int (left, right)
  int left, right;
{ return (left + ((int) (gen_random_float() * (right - left + 1)))); }


/* generate a random float over [0.0,1.0) */
float gen_random_float ()
{ return (((float) rand()) / RANDOM_RADIX); }


/* generate a random float over [left,right) */
float gen_random_range (left, right)
  float left, right;
{ return (left + gen_random_float() * (right - left)); }


void set_search_task (task)
  task_ task;
{ problem.task = task; }


void debug_node (message, node, sp)
  char *message;
  node_ *node;
  search_ *sp;
{
  if (message) printf("%s\n", message);

  if (node) {
    printf("node=%x, parent=%x, depth=%d, entity=%d, ",
		node, node->parent, node->depth, node->entity);
    if (problem.domain == INT || problem.domain == LONG)
      printf("g_cost=%d, lowb=%d, upb=%d, glub=%d, gllb=%d\n",
             node->g_cost, node->lowb, node->upb, sp->glub, sp->gllb);
    else
      printf("g_cost=%g, lowb=%g, upb=%g, glub=%g, gllb=%g\n",
             node->g_cost, node->lowb, node->upb, sp->glub, sp->gllb);
  }
}


void set_node_size (pdsd_size)
  long pdsd_size;
{ node_conf.node_size = (node_conf.pdsd_size = pdsd_size) + sizeof(node_); }


void junk() { printf("checkpoint\n"); }

