

/* ******************************************************************** *
 *	    WISE -- Whoever's Integrated Search Environment		*
 *									*
 *		          Lon-Chan Chu					*
 *		   	chu@crhc.uiuc.edu				*
 *	Center for Reliable and High-Performance Computing		*
 *		  Coordinated Science Laboratory			*
 *	    University of Illinois at Urbana-Champaign			*
 *									*
 *		     first revised, July 6, 1990			*
 *		    second revised, Sep 12, 1990			*
 * ******************************************************************** */

main (argc, argv)
  int argc;
  char *argv[];
{ int iter;
  search_ *top_sp;

  /* init some data structures */
  init_problem_struct(&problem);
  init_cmd_struct(&cmd);
  init_io_struct(&io);

  pool_manager = NULL;

  /* parse the command line */
  cmd_line(argc, argv);

  /* problem dependent initialization */
  iipd_init();

  /* start testbed execution wiht user-specified number of iterations */
  for (top_sp = NULL, iter = 1; iter <= cmd.iter; iter++) {

    /* feed the user-supplied seed to the random generator */
    srand(problem.seed);

    /* generate a sample problem for this iteration */
    gen_sample_problem();

    /* initialize environment for current iteration */
    top_sp = init_environ(top_sp);

    /* start search operation */
    search(top_sp);

    /* flush out final result */
    flush(top_sp);

#ifdef DEBUG
if (cmd.debug >= 2) evaluate_solution(top_sp);
#endif DEBUG

    /* keep the result of this iteration */
    if (problem.task == LEARNING) keep_result(iter, top_sp);

    /* free the environment */
    free_environ(top_sp, 0 /* not_top_level = 0 */);

    /* inc rand seed by one */
    problem.seed++;
  } /* iter loop */

  /* print out all the results to the output file named by argv[4] */
  if (problem.task == LEARNING) print_result(--iter, io.stat);
} /* main */

