yesno_ para_termination (pe, num_pe)
  search_ *pe[];
  int num_pe;
{ int i;
 
  for (i = 0; i < num_pe; i++)
    if (pe[i]->open.list) return NO;
  return YES;
}


void para_merge_solution (sp, pe, num_pe)
  search_ *sp;
  search_ *pe[];
  int num_pe;
{ int i;
  domain gllb, glub;
  solution_ *incumbent;

  gllb = pe[0]->gllb;
  glub = pe[0]->glub;
  incumbent = pe[0]->incumbent;
  for (i = 1; i < num_pe; i++)
  {
    if (gllb > pe[i]->gllb) gllb = pe[i]->gllb;
    if (glub > pe[i]->glub)
    {
      glub = pe[i]->glub;
      incumbent = pe[i]->incumbent;
    }
  }
  sp->approx.run_time = ((float) (glub - gllb)) / tofloat (gllb);
  sp->gllb = gllb;
  sp->glub = glub;
}


void para_merge_stat (sp, pe, num_pe)
  search_ *sp;
  search_ *pe[];
  int num_pe;
{ int i;
  stat_ *p = &(sp->stat), *c;

  for (i = 0; i < num_pe; i++)
  {
    c = &(pe[i]->stat);
    p->generated += c->generated;
    p->expanded += c->expanded;
    p->feasible += c->feasible;
    p->infeasible += c->infeasible;
    p->bounded += c->bounded;
    p->dominated += c->dominated;
    p->bounding += c->bounding;
    p->dominating += c->dominating;
    p->hard_bounded += c->hard_bounded;
    p->time += c->time;
    p->v_cst += c->v_cst;
    p->r_cst += c->r_cst;
    p->unix_utime += c->unix_utime;
    p->unix_stime += c->unix_stime;
  }

  p->active = pe[0]->stat.active;
  p->max_active = pe[0]->stat.max_active;
  for (i = 1; i < num_pe; i++)
  {
    c = &(pe[i]->stat);
    if (c->active > p->active) p->active = c->active;
    if (c->max_active > p->max_active) p->max_active = c->max_active;
  }
}


void para_load_balancing (pe, num_pe)
  search_ *pe[];
  int num_pe;
{ int i;
  node_ *p;

  for (i = 0; i < num_pe; i++)
  {
    if (pe[i]->open.list == NULL)
      if ((p = para_request (pe, i, num_pe))) insert (p, pe[i]);
  }
}


node_ *para_request (pe, who, num_pe)
  search_ *pe[];
  int who, num_pe;
{ int i;

  if (pe[who]->idle_clk >= cmd.comm_idle)
  {
    for (i = 0; i < num_pe; i++)
      if (pe[i]->stat.active > 1)
      {
        pe[who]->idle_clk = 0;
        return (delete (pe[i]));
      }
  } else (pe[who]->idle_clk)++;
  return NULL;
}

