
void update_stat (sp)
  search_ *sp;
{ stat_ *p = &(sp->stat);
  long interval;

  /* virtual time, space are set in 'insert'; virtual cst is set here */
  p->v_cst += tofloat(p->active);

  /* real time, space, cst are set here */
  times(&break_time); 
  p->time += (interval = (break_time.tms_utime - last_time.tms_utime));
  last_time = break_time;
  p->r_cst += ((float) (p->active * node_conf.node_size * interval));

  /* update max_active, if necessary */
  p->max_active = max(p->max_active,1+p->active);
} /* udpate_stat */


long get_time (sp)
  search_ *sp;
{
#ifdef TIME_IS_GEN
  return ((cmd.count == REAL) ? sp->stat.time : sp->stat.generated);
#else
  return ((cmd.count == REAL) ? sp->stat.time : sp->stat.expanded);
#endif
}


long get_space (sp)
  search_ *sp;
{ long space = sp->stat.active;

  if (cmd.count == REAL) space *= node_conf.node_size;
  return space;
}


long get_max_space (sp)
  search_ *sp;
{ long max_space = sp->stat.max_active;

  if (cmd.count == REAL) max_space *= node_conf.node_size;
  return max_space;
}


float get_cst (sp)
  search_ *sp;
{ return ((cmd.count == REAL) ? sp->stat.r_cst : sp->stat.v_cst); }


long get_pruned (sp)
  search_ *sp;
{ stat_ *p = &(sp->stat);

  return (p->bounded + p->dominated + p->bounding + p->dominating);
}


void merge_stat_to_parent (childp, parentp)
  search_ *childp, *parentp;
{ stat_ *p = &(parentp->stat), *c = &(childp->stat);
 
  p->generated += c->generated;
  p->expanded += c->expanded;
  p->feasible += c->feasible;
  p->infeasible += c->infeasible;
  p->active = c->active;	/* active space is not additive */
  p->bounded += c->bounded;
  p->dominated += c->dominated;
  p->bounding += c->bounding;
  p->dominating += c->dominating;
  p->hard_bounded += c->hard_bounded;
  if (c->max_active > p->max_active) p->max_active = c->max_active;
  p->time += c->time;
  p->v_cst += c->v_cst;
  p->r_cst += c->r_cst;
  p->unix_utime += c->unix_utime;
  p->unix_stime += c->unix_stime;
}


void merge_approx_to_parent (childp, parentp)
  search_ *childp, *parentp;
{
  parentp->approx.run_time = get_approx(childp);
  put_achieved_approx(parentp, parentp->approx.run_time);
}


void merge_sol_to_parent (childp, parentp)
  search_ *childp, *parentp;
{ 
  if (parentp->glub > childp->glub) {
    parentp->glub = childp->glub;
    parentp->incumbent = childp->incumbent;
  }
  parentp->gllb = childp->gllb; /** not meaningful **/
}


void inherit_sol_from_parent (childp, parentp)
  search_ *childp, *parentp;
{
  childp->incumbent = parentp->incumbent;
  childp->glub = childp->x_root_ub = parentp->glub;
  childp->x_root_lb = parentp->gllb;
  /** childp->gllb = childp->x_root_lb = parentp->gllb; **/
}


float get_offset_rt_approx (sp, offset_sp)
  search_ *sp, *offset_sp;
{ float rt_approx;

  rt_approx = get_approx(sp);
  if (offset_sp) rt_approx = (rt_approx < offset_sp->approx.achieved) ?
                             rt_approx : offset_sp->approx.achieved;
  return rt_approx;
}
  

long get_offset_time (sp, offset_sp)
  search_ *sp, *offset_sp;
{
  if (offset_sp) return (get_time (sp) + get_time (offset_sp));
  else return get_time (sp);
}


long get_offset_space (sp, offset_sp)
  search_ *sp, *offset_sp;
{ long space;

  if (offset_sp) space = sp->stat.active + offset_sp->stat.active; 
  else 		 space = sp->stat.active;
  if (cmd.count == REAL) space *= node_conf.node_size;
  return space;
} 


float get_offset_cst (sp, offset_sp) 
  search_ *sp, *offset_sp;
{
  if (cmd.count == REAL)
       if (offset_sp) return (sp->stat.r_cst + offset_sp->stat.r_cst); 
       else return sp->stat.r_cst;    
  else if (offset_sp) return (sp->stat.v_cst + offset_sp->stat.v_cst); 
       else return sp->stat.v_cst; 
}


long get_offset_max_space (sp, offset_sp)
  search_ *sp, *offset_sp;
{ long space;

  if (offset_sp) space = (sp->stat.max_active >= offset_sp->stat.max_active) ?
                         sp->stat.max_active : offset_sp->stat.max_active;
  else  	 space = sp->stat.max_active;
  if (cmd.count == REAL) space *= node_conf.node_size;
  return space;
}


long get_offset_gen (sp, offset_sp)
  search_ *sp, *offset_sp;
{
  return (((offset_sp) ? (sp->stat.generated + offset_sp->stat.generated) :
                         (sp->stat.generated)));
}

