
#ifdef BPLUS_TREE

#ifdef LOWB_PLUS_GCOST
#define	bptree_sort_key(node)	(node->lowb * LPG_LARGE_CONST - node->g_cost)
#else
#define	bptree_sort_key(node)	(node->lowb)
#endif

/* insert a node into a b_plus tree, ascendingly */
void bptree_insert (node, sp)
  node_ *node;
  search_ *sp;
{ node_ *p;
  domain node_key;

  node->left = node->right = NULL;

  if (sp->strategy != BAND && sp->strategy != FBS)
    if (sp->stat.active < 0) sp->stat.active = 0;
    else sp->stat.active++;

  if (sp->open.bptree) {
    node_key = bptree_sort_key(node);

    for (p = sp->open.bptree; p; ) {
      if (node_key < bptree_sort_key(p)) {
        if (p->left) p = p->left;
        else {
          p->left = node;
          node->up = p;
          return;
        }
      } else {
        if (p->right) p = p->right;
        else {
          p->right = node;
          node->up = p;
          return;
        }
      }
    }

    error ("bptree_insert: Internal error");
  }

  sp->open.bptree = node;
  node->up = NULL;
}



/* delete a node from a b_plus tree */
node_ *bptree_delete (sp)
  search_ *sp;
{ node_ *p;

  if (sp->open.bptree) {
    for (p = sp->open.bptree; p->left; p = p->left) ;
    if (p == sp->open.bptree) {
      sp->open.bptree = p->right;
      if (p->right) p->right->up = NULL;
    } else {
      p->up->left = p->right;
      if (p->right) p->right->up = p->up;
    }
    p->left = p->right = p->up = NULL;

    if (sp->strategy != BAND && sp->strategy != FBS)
      if(sp->stat.active <= 0) sp->stat.active = 0;
      else sp->stat.active--;

    return p;
  }

  if (sp->strategy != BAND && sp->strategy != FBS) sp->stat.active = 0;
  return NULL;
}



int is_bptree_empty (sp)
  search_ *sp;
{ return (sp->open.bptree == NULL); }


#undef	bptree_sort_key(node)

#else BPLUS_TREE

void bptree_insert (node, sp)
  node_ *node;
  search_ *sp;
{ btree_insert (node, sp); }

node_ *bptree_delete (sp)
  search_ *sp;
{ return btree_delete (sp); }

int is_bptree_empty (sp)
  search_ *sp;
{ return is_btree_empty (sp); }

#endif

