

#ifdef LOWB_PLUS_GCOST
#define btree_sort_key(node)   (node->lowb * LPG_LARGE_CONST - node->g_cost)
#else
#define btree_sort_key(node)   (node->lowb)
#endif


/* insert a node into a virtual b+ tree, ascendingly */
void btree_insert (node, sp)
  node_ *node;
  search_ *sp;
{ node_ *p, *q;
  domain node_key;

  if (sp->strategy != BAND && sp->strategy != FBS)
    if (sp->stat.active < 0) sp->stat.active = 0;
    else sp->stat.active++;

  if (sp->open.btree) {
    node_key = btree_sort_key(node);
    for (q = p = sp->open.btree; p; p = (q = p)->next) {
      if (node_key < btree_sort_key(p)) {
        if (p == sp->open.btree) {
          (sp->open.btree = node)->next = p;
          return;
        }
        else {
          (q->next = node)->next = p;
          return;
        } /* if-then-else */
      } /* if-then */
    } /* for */
    if (! p) (q->next = node)->next = NULL;
  }
  else (sp->open.btree = node)->next = NULL;
}


/* delete a node from a b+ tree */
node_ *btree_delete (sp)
  search_ *sp;
{ node_ *q;

  if (sp->open.btree) sp->open.btree = (q = sp->open.btree)->next;
  else {
    if (sp->strategy != BAND && sp->strategy != FBS) sp->stat.active = 0;
    return NULL;
  }

  if (sp->strategy != BAND && sp->strategy != FBS)
    if(sp->stat.active <= 0) sp->stat.active = 0;
    else sp->stat.active--;

  return q;
}


int is_btree_empty (sp)
  search_ *sp;
{ return (sp->open.btree == NULL); }


#ifdef SWAP_BAND_NODE
node_ *swap_band_node (node, sp)
  node_ *node;
  search_ *sp;
{ node_ *p, *q, *temp;
  domain node_key;

  if (sp->open.btree) {
    node_key = btree_sort_key(node);
    for (q = p = sp->open.btree; p; p = (q = p)->next) {
      if (node->depth == p->depth && node_key < btree_sort_key(p)) {
        if (p == sp->open.btree) (sp->open.btree = node)->next = p->next;
        else (q->next = node)->next = p->next;
	temp = p; p = node; node = temp;  /** swap **/
        node_key = btree_sort_key(node);
      } /* if-then */
    } /* for */
  }

  return node;
}

#endif

#undef	btree_sort_key(node)

