
node_ *get_search_node_from_pool ()
{ int offset, *pool, i;
  node_ *p;

  /* if the pool of search nodes are empty, then
   * allocate AllocationSize search nodes at a time to avoid
   * spreadout of search nodes to entire virtual
   * memory.
   */

#ifdef DEBUG
if (cmd.debug >= 4) printf("enter get_search_node_from_pool\n");
#endif

  offset = node_conf.node_size / sizeof(int);
  if (! pool_manager) {  /* request space from OS */

#ifdef DEBUG
if (cmd.debug >= 4) printf("allocate main body\n");
#endif
    /* allocate entire chunk of search nodes, including
     * main body and associative regions
     */
    pool = (int *) malloc(AllocationSize * node_conf.node_size);
    pool_manager = (node_ *) pool;

    for (i = 0; i < AllocationSize; i++) {
      p = ((node_ *) (pool + offset * i));
      p->next = ((node_ *) (pool + offset * (i + 1)));
    }
    p->next = NULL;
    
    pd_region();
  }

#ifdef DEBUG
if (cmd.debug >= 4) printf("now, get a search node\n");
#endif

  /* now, pool has free search nodes */
  pool_manager = (p = pool_manager)->next;
  NumNodesTaken++;
  return p;
}


void dispose_search_node_to_pool (node)
  node_ *node;
{
  node->next = pool_manager;
  pool_manager = node;
  NumNodesTaken--;
}

