
void insert (node, sp)
  node_ *node;
  search_ *sp;
{
  switch (sp->strategy) {
    case GBB:  list_insert(node, sp);  break;
    case BFS:  bptree_insert(node, sp); break;
    case DFS:  stack_push(node, sp);   break;
    case GDFS: list_insert(node, sp);  break;
    case FBS:  /** first-band search **/
    case BAND: node->brother = NULL;
	       put_band_node (node, sp); break;
    default:   list_insert(node, sp);  break;
  }
}


node_ *delete (sp)
  search_ *sp;
{
  switch (sp->strategy) {
    case GBB:  return list_delete(sp);    break;
    case BFS:  return bptree_delete(sp);   break;    
    case DFS:  return stack_top(sp);      break;   
    case GDFS: return list_delete(sp);    break;
    case FBS:  /** first-band search **/
    case BAND: return get_band_node (sp); break;
    default:   return list_delete(sp);    break; 
  } 
}


domain sort_key (node, sp)
  node_ *node;
  search_ *sp;
{ domain key;

  switch (sp->strategy) {
  case FBS:  /** first-band search **/
  case BAND:
  case BFS:
#ifdef LOWB_PLUS_GCOST
	return (node->lowb * LPG_LARGE_CONST - node->g_cost);
#else
	return node->lowb;
#endif
	break;
  default:
    key = (domain) (HUGE_DEPTH - node->depth);
    return key;
    break;
  }
}


int is_open_empty (sp)
  search_ *sp;
{ return (sp->stat.active == 0); }

