
typedef float decomp_;
decomp_ decomp_h_fun ();
decomp_ dh_val[MaxProblemSize];
node_ *ch_arr[MaxProblemSize];


node_ *expand (node, child_type, nchild)
  node_ *node;
  child_ child_type;
  int nchild;
{ int entity = node->entity; 
  domain g_cost = node->g_cost;
  node_ *new_list = NULL;
  node_ *child, *next_child;
  int i, count = 0, who;
  domain w;
  decomp_ best;
  
  switch (child_type) {
  case ALL_CHILDREN:  nchild = HUGE_INT;
  case NEXT_N_CHILDREN:

    /** init **/
    for (i = 0; i < nCities; i++) {
      dh_val[i] = HUGE_FLOAT;
      ch_arr[i] = NULL;
    }

    /** sprout all necessary children **/
    for (i = 1; i < nCities; i++)
      if (*(node->open+i)) {
        *(node->open+i) = 0;
        w = Weight (entity, i);
        if (w != problem.huge) {
          ch_arr[i] = allocate_node (node, i, g_cost+w);
          dh_val[i] = decomp_h_fun (node, ch_arr[i]);
          if (++count >= nchild) break;
        }
    }

    /** sort all these children by decomp heuristic values **/
    while (count-- > 0) {
      best = HUGE_FLOAT;
      who = -1;
      for (i = 1; i < nCities; i++)
        if (best > dh_val[i]) { best = dh_val[i]; who = i; }
      ch_arr[who]->next = new_list;
      new_list = ch_arr[who];
      dh_val[who] = HUGE_FLOAT;
    } 

    /** reverse new_list **/
    next_child = new_list;
    new_list = NULL;
    while ((child = next_child)) {
      next_child = child->next;
      child->next = NULL;
      child->brother = new_list;
      new_list = child;
    }

    return new_list;
    break;

  case NEXT_CHILD:
    for (i = 1; i < nCities; i++)
      if (*(node->open+i)) {
	*(node->open+i) = 0;
        w = Weight (entity, i);
        if (w != problem.huge) return allocate_node (node, i, g_cost+w);
      }
    break;

  default: break;
  }

  return NULL;
}


decomp_ decomp_h_fun (node, child)
  node_ *node, *child;
{
  return Weight (node->entity, child->entity);
}


int is_infeasible (node)
  node_ *node;
{ int v;

  /* an infeasible node must be a compound node in the complete graph,
   * but could be a simple node in incomplete graph
   */
  if (node->nvisit == nCities) return 0;
  for (v = 0; v < nCities; v++)
    if (*(node->open+v)) return 0;
  return 1;
}


int is_feasible (node)
  node_ *node;
{
  if (node->nvisit == nCities)
    return ((Weight (node->entity, 0) == problem.huge) ? 0 : 1);
  else return 0;
}


int is_pre_goal (node)
  node_ *node;
{ int v, edge;

  if (node->nvisit == nCities)
    if (Weight (node->entity, 0) != problem.huge) {
      node->g_cost += Weight (node->entity, 0);
      return 1;
    }
  return 0;
}

