
node_ *root_generator () { return allocate_node(NULL, 0, 0.0); }


/* iteration-independent problem-dependent init */
void iipd_init () {
  int size = problem.size;

  /* create weight matrix */
  WEIGHT = (float *) malloc(size * size * sizeof(float));
  SORTW = (int *) malloc(size * size * sizeof(int));
}


void idpd_init () { }

int is_dominated (node) node_ *node; { return 0; }


/* node allocation routine */
node_ *allocate_node (parentp, entity, g_cost)
  node_ *parentp;
  int entity;
  domain g_cost;
{ node_ *p;
  int i;

  p = get_search_node_from_pool();
  init_node_struct(p, parentp);

  p->entity = entity;
  p->g_cost = g_cost;

  /* clean thses value fields */
  if (parentp) {
    p->lowb = parentp->lowb;
    p->upb = parentp->upb;
  } else {
    p->lowb = - problem.huge;
    p->upb = problem.huge;
  }

  /* init *visited associate */
  if (parentp) {
    for (i = 0; i < parentp->nvisit; i++)
      *(p->visited + i) = *(parentp->visited + i);
    p->nvisit = parentp->nvisit + 1;
    *(p->visited + parentp->nvisit) = entity;
  }
  else {
    p->nvisit = 1;
    *(p->visited) = entity;
  }

  /* init *open associate */
  trace_live(p);
  for (i = 0; i < nCities; i++)
    *(p->open+i) = (LiveCity[i] && Weight(entity,i) != problem.huge) ? 1 : 0;

  return p;
}


/* allocate associates for newly allocated search nodes */
void pd_region ()
{ int offset, *pool, visited_offset, open_offset, *a, i;
  node_ *p;
    
  pool = (int *) pool_manager;
  offset = node_conf.node_size / sizeof(int);
  visited_offset = sizeof(node_) / sizeof(int);
  open_offset = visited_offset + nCities;

  for (i = 0; i < AllocationSize; i++) {
    p = ((node_ *) (a = pool + offset * i));
    p->visited = a + visited_offset;	/* allocate *visited frame */ 
    p->open = a + open_offset;		/* allocate *open frame */
  }
}


void reset_sol_buf (s)
  solution_ *s;
{ int i;

  for (i = 0; i < problem.size; i++) s->city[i] = 0;
}


/* for debug */
void print_conf (fp)
  FILE *fp;
{ int i, j;

  fprintf(fp, "nCities=%d,  nRoads=%d\n", nCities, nRoads);
  for (i = 0; i < nCities; i++) {
    fprintf(fp, "\n");
    for (j = 0; j < nCities; j++)
      if (Weight(i,j) != problem.huge)  fprintf(fp, " %6f ", Weight(i,j));
      else 		 	 	fprintf(fp, " huge ");
  }
  fprintf(fp, "\n");
}


void evaluate_solution (sp)
  search_ *sp;
{ solution_ *sol;
  int i;

  if (sp) sol = sp->incumbent;
  else error("evaulate_solution: internal error: sp is nil");
  printf("\nSOLUTION:\n");
  for (i = 0; i < nCities; i++) printf("%d-th city is  %d\n", i, sol->city[i]);
}

