#ifndef	__GRCS_define_h_
#define	__GRCS_define_h_

#define MIN_DELTA_TH	1

typedef	float	domain;
#define Domain	FLOAT

#define	MaxProblemSize	160
#define AllocationSize	256

#define	PDSI_PART	\
	domain	*proc_ck;	/** processor's clocks **/		\
	domain	*resource_ck;	/** resource's clocks **/		\
	int	*open_task;	/** open pointer, to be selected **/	\
	float	*sched_time;	/** scheduled times of tasks **/


typedef struct
{
        domain	schedTime[MaxProblemSize];
} solution_;


#define NOT_SCHED	(-1.0)

#define	is_task_alive(node,i)	(*(node->sched_time + i) < 0.0)
#define	is_task_sched(node,i)	(*(node->sched_time + i) >= 0.0)
#define set_task_alive(node,i)	*(node->sched_time + i) = NOT_SCHED
#define	get_task_time(node,i)	(*(node->sched_time + i))
#define	set_task_time(node,i,t)	*(node->sched_time + i) = t



#define _n_R_Low	4		/* num of resources */
#define _n_R_Up		4
#define _n_P_Low	3		/* num of processors */
#define _n_P_Up		3
#define	_T_Low		10.0		/** exec time **/
#define _T_Up		100.0

#define MaxResource	(_n_R_Up + 2)
#define MaxProcessor	(_n_P_Up + 2)

#endif	__GRCS_define_h_

