
typedef float decomp_;
decomp_ decomp_h_fun ();
decomp_ dh_val[MaxProblemSize];
node_ *ch_arr[MaxProblemSize];


node_ *expand (node, child_type, nchild)
  node_ *node;
  child_ child_type;
  int nchild;
{ int entity = node->entity; 
  domain g_cost = node->g_cost;
  node_ *new_list = NULL;
  node_ *child, *next_child;
  int i, count = 0, who;
  domain w;
  decomp_ best;
  
  switch (child_type) {
  case ALL_CHILDREN:  nchild = HUGE_INT;
  case NEXT_N_CHILDREN:

    /** init **/
    for (i = 0; i < nTasks; i++) {
      dh_val[i] = (decomp_) 0;;
      ch_arr[i] = NULL;
    }

    /** sprout all necessary children **/
    for (i = 0; i < nTasks; i++)
      if (*(node->open_task+i)) {
        *(node->open_task+i) = 0;
        ch_arr[i] = allocate_node (node, i);
        dh_val[i] = decomp_h_fun (i);
        if (++count >= nchild) break;
      }

    /** sort all these children by decomp heuristic values **/
    while (count-- > 0) {
      best = (decomp_) 0;
      who = -1;
      for (i = 0; i < nTasks; i++)
        if (best < dh_val[i]) { best = dh_val[i]; who = i; }
      ch_arr[who]->next = new_list;
      new_list = ch_arr[who];
      dh_val[who] = (decomp_) 0;
    } 

    /** reverse new_list **/
    next_child = new_list;
    new_list = NULL;
    while ((child = next_child)) {
      next_child = child->next;
      child->next = NULL;
      child->brother = new_list;
      new_list = child;
    }

    return new_list;
    break;

  case NEXT_CHILD:
    for (i = 0; i < nTasks; i++)
      if (*(node->open_task+i)) {
	*(node->open_task+i) = 0;
        return allocate_node (node, i);
      }
    break;

  default: break;
  }

  return NULL;
}


decomp_ decomp_h_fun (entity)
  int entity;
{
  return ((decomp_) execTime[entity]);
}


int is_infeasible (node)
  node_ *node;
{ return 0; }


int is_feasible (node)
  node_ *node;
{ int i;

  for (i = 0; i < nTasks; i++)
    if (is_task_alive (node, i)) return 0;

  return 1;
}

