
domain ks_eval_lowb (), ks_eval_upb ();


void evaluate_lower_bound (node)
  node_ *node;
{
  node->lowb = is_feasible (node) ? node->g_cost : ks_eval_lowb (node);
}


domain ks_eval_lowb (node)
  node_ *node;
{ int w_sum = node->w, i, diff, goal = 1;
  float lookahead, ratio;

  if (w_sum >= BOUND)  /* goal node already */ return node->g_cost;

  /* find min penalty & max weight */
  for (i = 1; i <= U; i++)
    if (*(node->item + sortP[i] - 1)) {
      ratio = PdivW[sortP[i]];
      goal = 0;
      break;
    }

  if (goal) return node->g_cost;

  diff = BOUND - w_sum;
  lookahead = tofloat (diff) * ratio;
  return (node->g_cost + toint (lookahead));
}


solution_ *evaluate_upper_bound(node, sol)
  node_ *node;
  solution_ *sol;
{
  node->upb = is_feasible (node) ? node->g_cost : ks_eval_upb (node, sol);
  return sol;
}

domain ks_eval_upb (node, sol)
  node_ *node;
  solution_ *sol;
{ domain p_sum = node->g_cost;
  int w_sum = node->w, i, *itemp, *ip;

  itemp = node->item;
  for(i = 1; i <= U; i++) {
    if(w_sum < BOUND) {
      ip = itemp + sortP[i] - 1;
      if(*ip) {
        w_sum += W[sortP[i]];
        p_sum += P[sortP[i]];
      }
    }
    else break;
  }

  if(w_sum < BOUND)
    /* infeasible */
    return problem.huge;

  return p_sum;
}

