#ifndef __node_h_
#define __node_h_

#define MIN_DELTA_TH	1

typedef	int	domain;
#define Domain	INT

#define AllocationSize         256

#define	PDSI_PART \
	int	w;	/* acc weight */  \
	int   	*item;	/* item pointer */


/** not for learning **/
#ifndef TEACHER

#define	_W_Low			1
#define _W_Up			1000

#ifdef	CLASS_CONST
#define _Variance		1.05
#else
#define _Variance		1.5
#endif


#else TEACHER


/** Large variance of weights, Medium variance of profit-weight ratios.  **/
#ifdef CLASS_1
#define	_W_Low			1
#define _W_Up			1000
#define _Variance		1.5
#endif

/** Large variance of weights, Large variance of profit-weight ratios.  **/
#ifdef CLASS_2
#define	_W_Low			1
#define _W_Up			1000
#define _Variance		10
#endif

/** Large variance of weights, Small variance of profit-weight ratios.  **/
#ifdef CLASS_3
#define	_W_Low			1
#define _W_Up			1000
#define _Variance		1.05
#endif

/** Large variance of weights, Random profit-weight ratios.  **/
#ifdef CLASS_4
#define	_W_Low			1
#define _W_Up			1000
#define _Variance		100
#endif

/** Medium variance of weights, Medium variance of profit-weight ratios.  **/
#ifdef CLASS_5
#define	_W_Low			100
#define _W_Up			200
#define _Variance		1.5
#endif

/** Medium variance of weights, Large variance of profit-weight ratios.  **/
#ifdef CLASS_6
#define	_W_Low			100
#define _W_Up			200
#define _Variance		10
#endif

/** Medium variance of weights, Small variance of profit-weight ratios.  **/
#ifdef CLASS_7
#define	_W_Low			100
#define _W_Up			200
#define _Variance		1.05
#endif

/** Small variance of weights, Medium variance of profit-weight ratios.  **/
#ifdef CLASS_8
#define	_W_Low			100
#define _W_Up			105
#define _Variance		1.5
#endif

/** Small variance of weights, Large variance of profit-weight ratios.  **/
#ifdef CLASS_9
#define	_W_Low			100
#define _W_Up			105
#define _Variance		10
#endif

/** Small variance of weights, Small variance of profit-weight ratios.  **/
#ifdef CLASS_10
#define	_W_Low			100
#define _W_Up			105
#define _Variance		1.05
#endif


#endif    TEACHER


#define	MaxProblemSize		550

typedef struct
{
	int	not_in_sack[MaxProblemSize + 1];
} solution_;

extern int 	U;		/* # items */
extern int	B;		/* bound of weight */
extern int	BOUND;		/* lowb sum of weight of not included items */
extern int	PP;		/* overall sum of profits */
extern int	WW;		/* overall sum of weights */
extern int	W[MaxProblemSize];	/* weights */
extern int	P[MaxProblemSize];	/* profit */
extern int	sortP[MaxProblemSize];
extern float	PdivW[MaxProblemSize];

#endif __node_h_

