
void gen_sample_problem ()
{ int i, j, best_one, tmp, min_w, size;
  float best, b_float;

  /* generate the problem size randomly */
  U = size = problem.size;

  /* generate the problem parameters randomly */
  min_w = _W_Up + 1;
  WW = PP = W[0] = P[0] = 0;
  for (j = 1; j <= U; j++) {
    WW += (W[j] = gen_random_int(_W_Low, _W_Up));
    PP += (P[j] = W[j] * gen_random_range(1.0, _Variance));
    if (W[j] < min_w) min_w = W[j];
  }

  /* generate the total weight bound */
  b_float = ((float) (WW - min_w)) * gen_random_range(0.4, 0.6);
  BOUND = WW - (B = min_w + toint(b_float));

  /* sort P array into sortP of which value is index ordering ascendingly */
  for (i = 1; i <= U; i++) {
    PdivW[i] = tofloat(P[i]) / tofloat(W[i]);
    sortP[i] = i;
  }
  for (i = 1; i < U; i++) {
    best_one = i;
    best = PdivW[sortP[best_one]];
    for (j = i+1; j <= U; j++)
      if (PdivW[sortP[j]] < best) { best_one = j; best = PdivW[sortP[j]]; }
    tmp = sortP[i];
    sortP[i] = sortP[best_one];
    sortP[best_one] = tmp;
  }

#ifdef DEBUG
if (cmd.debug >= 2)
  for (i = 1; i <= U; i++)
    printf("P[%d]=%d, W[%d]=%d\n", i, P[i], i, W[i]);
#endif

  set_node_size(U * sizeof(int));
}

