
node_ *root_generator ()
{
  /* generate a root node with
   * parent = nil, entity = 0, g_cost = 0, w = 0
   */
  return allocate_node(NULL, 0, 0, 0);
}

/* problem dependent initialization */
void iipd_init ()
{ int i;

  for (i = 0; i < MaxProblemSize; i++) Dom[i] = NULL;
}

/* problem dependent environmental initialization for each iteration */
void idpd_init () { dom_init(); }


/* max sum profit = min sum penalty
 * profit:  items selected for packing constitue profit
 * penalty: items not selected constitute penalty
 * feature: min penalty and the sum of penalty increase from 0
 * all p, w, and cost are positive
 */
node_ *allocate_node (parentp, entity, g_cost, w)
  node_ *parentp;
  int entity, g_cost, w;
{ node_	*p;
  int k;

  p = get_search_node_from_pool();
  init_node_struct(p, parentp);

  p->entity = entity;
  p->g_cost = g_cost;
  p->w = w;

  /* clean these value fields */
  p->lowb = - problem.huge;
  p->upb = problem.huge;

  if (parentp) {
    for (k = 0; k < U; k++) *(p->item+k) = *(parentp->item+k);
    *(p->item+entity-1) = 0;
  } else {
    for(k = 0; k < U; k++) *(p->item+k) = 1;
  }

  return p;
}


/* allocate associates for newly allocated search nodes */
void pd_region ()
{ int offset, *pool, item_offset, *a, i;
  node_ *p;
    
  pool = (int *) pool_manager;
  offset = node_conf.node_size / sizeof(int);
  item_offset = sizeof(node_) / sizeof(int);

  for (i = 0; i < AllocationSize; i++) {
    p = ((node_ *) (a = pool + offset * i));

    /* allocate *item frame */ 
    p->item = a + item_offset;
  }
}


void reset_sol_buf (s)
  solution_ *s;
{ int i;

  for (i = 0; i < problem.size; i++) s->not_in_sack[i] = 0;
}


/* for debug */
void print_conf (fp)
  FILE *fp;
{ int i;

  fprintf(fp, "U=%d, B=%d, BOUND=%d, WW=%d, PP=%d\n", U, B, BOUND, WW, PP);
  for (i = 1; i <= U; i++)
    fprintf(fp, "W[%d]=%d, P[%d]=%d\n", i, W[i], i, P[i]);
}


void evaluate_solution (sp)
  search_ *sp;
{ solution_ *sol;
  int i;

  if (sp) sol = sp->incumbent;
  else error("evaulate_solution: internal error: sp is nil");
  printf("\nSOLUTION:\n");
  for (i = 1; i <= problem.size; i++)
    if (sol->not_in_sack[i] >= 0)
      printf("%d-th object not in sack is  %d\n", i, sol->not_in_sack[i]);
    else break;
}

