
void evaluate_lower_bound (node)
    node_ *node;
{
#ifdef DEBUG
if (cmd.debug >= 4) printf("eval lowb\n");
#endif

    node->lowb = node->g_cost + (domain) calc_goal_distance (node->x, node->y);
}


solution_ *evaluate_upper_bound (node, sol)
    node_ *node;
    solution_ *sol;
{   int count;
    node_ *p;
#ifdef DEBUG
if (cmd.debug >= 4) printf("eval upb\n");
#endif

    if (is_feasible (node)) {
	/** calc how many moves so far **/
	for (count = 0, p = node; p; p = p->parent) count++;
	sol->dir[count] = (solelmt_) NOT_USED_DIR;
 
	for (p = node; p; p = p->parent) {
	    --count;
            sol->x[count] = (solelmt_) p->x;
            sol->y[count] = (solelmt_) p->y;
            sol->dir[count] = (solelmt_) p->entity;
	}

        node->upb = node->g_cost;
    }
#ifdef NO_UPPER_BOUND
    else node->upb = problem.huge;
#else
    else node->upb = maze_eval_upb (node, sol);
#endif

    return sol;
}


domain maze_eval_upb (node, sol)
    node_ *node;
    solution_ *sol;
{   directn curr_dir = node->entity;
    int curr_x = node->x;
    int curr_y = node->y;
    domain num_moves = 0;
    int i, who, new_x, new_y, count, new, best_x, best_y;
    directn new_dir, best_dir;
    domain best, dist;
    node_ *p;
    yesno_ pre_move ();

    /** calc how many moves so far **/
    for (count = 0, p = node; p; p = p->parent) count++;
    new = count;

    for (p = node; p; p = p->parent) {
	--count;
	sol->x[count] = (solelmt_) p->x;
	sol->y[count] = (solelmt_) p->y;
	sol->dir[count] = (solelmt_) p->entity;
    }

    num_moves = 0;
    moves[0].x = curr_x;
    moves[0].y = curr_y;
    while (1) {
	best = problem.huge;
	who = -1;
	for (i = 1; i <= 4; i++) {
	    if (pre_move (curr_dir, curr_x, curr_y, i,
			  &new_dir, &new_x, &new_y, num_moves) == YES) {
		dist = calc_goal_distance (new_x, new_y);
		if (best > dist) {
		    best = dist;
		    who = i;
		    best_x = new_x;
		    best_y = new_y;
		    best_dir = new_dir;
		}
	    }
	}

	if (who == -1) break;
	++num_moves;
        if (num_moves + node->g_cost >= X * Y) { who = -1; break; }

	curr_dir = best_dir;
	moves[num_moves].x = curr_x = best_x;
	moves[num_moves].y = curr_y = best_y;

	sol->x[new] = (solelmt_) best_x;
	sol->y[new] = (solelmt_) best_y;
	sol->dir[new] = (solelmt_) best_dir;
	++new;

	if (best == (domain) 0) break;
    }

    sol->dir[new] = (solelmt_) NOT_USED_DIR;

    return ((who == -1) ? problem.huge : (node->g_cost + num_moves));
}


yesno_ pre_move (curr_dir, curr_x, curr_y, which, new_dirp, new_xp, new_yp, num_moves)
    directn curr_dir;
    int curr_x, curr_y, which;
    directn *new_dirp;
    int *new_xp, *new_yp;
    domain num_moves;
{   yesno_ is_pre_movable ();

    if (curr_dir == AntiDirection[which]) return NO;

    if (is_pre_movable (curr_x, curr_y, Direction[which], num_moves) == YES) {
	switch ((*new_dirp = Direction[which])) {
	case EAST:  *new_xp = curr_x+1;	*new_yp = curr_y;	break;
	case SOUTH: *new_xp = curr_x;	*new_yp = curr_y+1;	break;
	case WEST:  *new_xp = curr_x-1;	*new_yp = curr_y;	break;
	case NORTH: *new_xp = curr_x;	*new_yp = curr_y-1;	break;
	}
	return YES;
    }

    return NO;
}


yesno_ is_pre_movable (x, y, dir, num_moves)
    int x, y;
    directn dir;
    domain num_moves;
{   int i;

    switch (dir) {
    case EAST:
	if (has_east_wall (maze[x][y])) return NO;
	if (++x >= X) return NO;
	break;
    case SOUTH:
	if (has_south_wall (maze[x][y])) return NO;
	if (++y >= Y) return NO;
	break;
    case WEST:
	if (has_west_wall (maze[x][y])) return NO;
	if (--x < 0) return NO;
	break;
    case NORTH:
	if (has_north_wall (maze[x][y])) return NO;
	if (--y < 0) return NO;
	break;
    default:
	return NO;
	break;
    }

    /** check whether this point has been visited or not **/
    for (i = 0; i <= num_moves; i++)
	if (x == moves[i].x && y == moves[i].y) return NO;

    return YES;
}


int calc_goal_distance (x, y)
    int x, y;
{   int d, error;

    d = x - X_end;
    if (d < 0) d = -d;
    error = d;

    d = y - Y_end;
    if (d < 0) d = -d;
    error += d;

    return error;
}

