
#ifndef __MAZE_define_h__
#define __MAZE_define_h__

/** this compiler definition is very essential, please don't delete it **/
#define DELAY_FREE_NODE

#define MIN_DELTA_TH	1

typedef long			domain;
#define Domain			LONG

#define AllocationSize		256
#define MaxProblemSize		130
#define	PDSI_PART		int x, y;

#define MAX_X_SIZE		MaxProblemSize
#define MAX_Y_SIZE		MaxProblemSize

#define LPG_LARGE_CONST		(MaxProblemSize * MaxProblemSize)

#if MaxProblemSize < 256
typedef char solelmt_;
#else
typedef int solelmt_;
#endif

typedef	struct {
	int		pre_buf;
	solelmt_	x[MAX_X_SIZE * MAX_Y_SIZE];
	solelmt_	y[MAX_X_SIZE * MAX_Y_SIZE];
	solelmt_	dir[MAX_X_SIZE * MAX_Y_SIZE];
	int		post_buf;
} solution_;

#define	EAST_WALL		(0x01)
#define	SOUTH_WALL		(0x02)
#define	WEST_WALL		(0x04)
#define	NORTH_WALL		(0x08)
#define	WALL			(0x0f)

#define	EAST_DOOR		(0x10)
#define	SOUTH_DOOR		(0x20)
#define	WEST_DOOR		(0x40)
#define	NORTH_DOOR		(0x80)
#define	DOOR			(0xf0)


#define set_east_wall(pt)	pt |= EAST_WALL
#define set_south_wall(pt)	pt |= SOUTH_WALL
#define set_west_wall(pt)	pt |= WEST_WALL
#define set_north_wall(pt)	pt |= NORTH_WALL

#define set_east_door(pt)	pt |= EAST_DOOR
#define set_south_door(pt)	pt |= SOUTH_DOOR
#define set_west_door(pt)	pt |= WEST_DOOR
#define set_north_door(pt)	pt |= NORTH_DOOR


#define rm_east_wall(pt)	pt &= (~ EAST_WALL)
#define rm_south_wall(pt)	pt &= (~ SOUTH_WALL)
#define rm_west_wall(pt)	pt &= (~ WEST_WALL)
#define rm_north_wall(pt)	pt &= (~ NORTH_WALL)

#define rm_east_door(pt)	pt &= (~ EAST_DOOR)
#define rm_south_door(pt)	pt &= (~ SOUTH_DOOR)
#define rm_west_door(pt)	pt &= (~ WEST_DOOR)
#define rm_north_door(pt)	pt &= (~ NORTH_DOOR)


#define has_east_wall(pt)	(pt & EAST_WALL)
#define has_south_wall(pt)	(pt & SOUTH_WALL)
#define has_west_wall(pt)	(pt & WEST_WALL)
#define has_north_wall(pt)	(pt & NORTH_WALL)

#define has_east_door(pt)	(pt & EAST_DOOR)
#define has_south_door(pt)	(pt & SOUTH_DOOR)
#define has_west_door(pt)	(pt & WEST_DOOR)
#define has_north_door(pt)	(pt & NORTH_DOOR)

#define has_wall(pt)		(pt & WALL)
#define has_door(pt)		(pt & DOOR)


typedef enum {
	NOT_YET = 0,
	EAST = 1,
	SOUTH = 2,
	WEST = 3,
	NORTH = 4,
	NOT_USED_DIR = 100	/** for empty slot in solution **/
} directn;

typedef struct { int x, y; } coord;

#endif	__MAZE_define_h__

