
int nrv_maze_conf;


void gen_sample_problem ()
{   int i, temp;
    directn door;
    FILE *fp, *fopen ();

    init_maze ();

    x = X_start;
    y = Y_start;
    idx_moves = 0;

    while (1) {
	moves[idx_moves].x = x;
	moves[idx_moves].y = y;

	/** select a new door **/
	while ((door = rand_door ()) == NOT_YET)
	    /** no more door available, and backtrack **/
	    if (backtrack () == NULL) {
#ifdef NRV_MAZE
    	    switch (nrv_maze_conf) {

    	    case 1: /** start at east wall **/
		set_east_wall (maze[X_start][Y_start]);
		set_west_wall (maze[X_end][Y_end]);
		break;

	    case 2: /** start at south wall **/
		set_south_wall (maze[X_start][Y_start]);
		set_north_wall (maze[X_end][Y_end]);
		break;

	    case 3: /** start at west wall **/
		set_west_wall (maze[X_start][Y_start]);
		set_east_wall (maze[X_end][Y_end]);
		break;

	    case 4: /** start at north wall **/
		set_north_wall (maze[X_start][Y_start]);
		set_south_wall (maze[X_end][Y_end]);
		break;
	    }

	    /** new source and destination of NRV_MAZE **/
	    X_start = X / 2;
	    Y_start = Y / 2;
	    X_end = gen_random_int (0, X-1);
	    Y_end = gen_random_int (0, Y-1);
#else
#ifdef MAZE_ENHANCE
		enhance_maze ();
#endif
#ifdef BACKWARD_GEN
		/** swap  start point  and  end point **/
		temp = X_start; X_start = X_end; X_end = temp;
		temp = Y_start; Y_start = Y_end; Y_end = temp;
#endif
#endif

#ifdef DEBUG
if (cmd.debug >= 1)
    printf ("X_start=%d, Y_start=%d;  X_end=%d, Y_end=%d\n",
	     X_start, Y_start, X_end, Y_end);
#endif

		/** PDSD size **/
		set_node_size (0);
		No_Upper_Bound = YES;

#ifdef MAZE_LAYOUT
		fp = fopen (".maze", "a");
		fprintf (fp, "MAZE(%d,%d,%d)\n",
				problem.size, problem.seed, take_out_percent);
		fclose (fp);
#endif

		return;
	    }

	idx_moves++;

	/** rm the wall and set the door, and move it **/
	switch (door) {

	case EAST:
	    rm_east_wall (maze[x][y]);
	    set_east_door (maze[x][y]);
	    x++;
	    rm_west_wall (maze[x][y]);
	    set_west_door (maze[x][y]);
	    break;

	case SOUTH:
	    rm_south_wall (maze[x][y]);
	    set_south_door (maze[x][y]);
	    y++;
	    rm_north_wall (maze[x][y]);
	    set_north_door (maze[x][y]);
	    break;

	case WEST:
	    rm_west_wall (maze[x][y]);
	    set_west_door (maze[x][y]);
	    x--;
	    rm_east_wall (maze[x][y]);
	    set_east_door (maze[x][y]);
	    break;

	case NORTH:
	    rm_north_wall (maze[x][y]);
	    set_north_door (maze[x][y]);
	    y--;
	    rm_south_wall (maze[x][y]);
	    set_south_door (maze[x][y]);
	    break;

	default: error ("gen_sample_problem: no such direction"); break;
	}
    } /** end while **/
}


void init_maze ()
{   int i, j;

    X = Y = problem.size;

    /** init all maze points **/
    for (i = 0; i < X; i++)
	for (j = 0; j < Y; j++) maze[i][j] = 0;

    /** draw borders **/
    for (j = 0; j < Y; j++) set_east_wall (maze[X-1][j]);
    for (i = 0; i < X; i++) set_south_wall (maze[i][Y-1]);
    for (j = 0; j < Y; j++) set_west_wall (maze[0][j]);
    for (i = 0; i < X; i++) set_north_wall (maze[i][0]);

    /** randomly generate start and end points **/
    switch ((nrv_maze_conf = gen_random_int (1,4))) {

    case 1: /** start at east wall **/
	X_start = X-1;
	Y_start = gen_random_int (0, Y-1);
	X_end = 0;
	Y_end = gen_random_int (0, Y-1);
	rm_east_wall (maze[X_start][Y_start]);
	set_east_door (maze[X_start][Y_start]);
	rm_west_wall (maze[X_end][Y_end]);
	set_west_door (maze[X_end][Y_end]);
	break;

    case 2: /** start at south wall **/
	X_start = gen_random_int (0, X-1);
	Y_start = Y-1;
	X_end = gen_random_int (0, X-1);
	Y_end = 0;
	rm_south_wall (maze[X_start][Y_start]);
	set_south_door (maze[X_start][Y_start]);
	rm_north_wall (maze[X_end][Y_end]);
	set_north_door (maze[X_end][Y_end]);
	break;

    case 3: /** start at west wall **/
	X_start = 0;
	Y_start = gen_random_int (0, Y-1);
	X_end = X-1;
	Y_end = gen_random_int (0, Y-1);
	rm_west_wall (maze[X_start][Y_start]);
	set_west_door (maze[X_start][Y_start]);
	rm_east_wall (maze[X_end][Y_end]);
	set_east_door (maze[X_end][Y_end]);
	break;

    case 4: /** start at north wall **/
	X_start = gen_random_int (0, X-1);
	Y_start = 0;
	X_end = gen_random_int (0, X-1);
	Y_end = Y-1;
	rm_north_wall (maze[X_start][Y_start]);
	set_north_door (maze[X_start][Y_start]);
	rm_south_wall (maze[X_end][Y_end]);
	set_south_door (maze[X_end][Y_end]);
	break;
    }
}


directn rand_door () /** select a new door randomly **/
{   directn dir[4];
    int num_dir = 0;

    /** think about east **/
    if (! (has_east_door (maze[x][y]) || has_east_wall (maze[x][y]))) {
	if (has_door (maze[x+1][y]) && (x+1 != X_end || y != Y_end)) {
#ifdef MAZE_ENHANCE
	    if (gen_random_int (1, 100) > take_out_percent) {
	        set_east_wall (maze[x][y]);
	        set_west_wall (maze[x+1][y]);
	    }
#else
	    set_east_wall (maze[x][y]);
	    set_west_wall (maze[x+1][y]);
#endif
	} else dir[num_dir++] = EAST;
    }

    /** think about south **/
    if (! (has_south_door (maze[x][y]) || has_south_wall (maze[x][y]))) {
	if (has_door (maze[x][y+1]) && (x != X_end || y+1 != Y_end)) {
#ifdef MAZE_ENHANCE
	    if (gen_random_int (1, 100) > take_out_percent) {
	        set_south_wall (maze[x][y]);
	        set_north_wall (maze[x][y+1]);
	    }
#else
	    set_south_wall (maze[x][y]);
	    set_north_wall (maze[x][y+1]);
#endif
	} else dir[num_dir++] = SOUTH;
    }

    /** think about west **/
    if (! (has_west_door (maze[x][y]) || has_west_wall (maze[x][y]))) {
	if (has_door (maze[x-1][y]) && (x-1 != X_end || y != Y_end)) {
#ifdef MAZE_ENHANCE
	    if (gen_random_int (1, 100) > take_out_percent) {
	 	set_west_wall (maze[x][y]);
	    	set_east_wall (maze[x-1][y]);
	    }
#else
	    set_west_wall (maze[x][y]);
	    set_east_wall (maze[x-1][y]);
#endif
	} else dir[num_dir++] = WEST;
    }

    /** think about north **/
    if (! (has_north_door (maze[x][y]) || has_north_wall (maze[x][y]))) {
	if (has_door (maze[x][y-1]) && (x != X_end || y-1 != Y_end)) {
#ifdef MAZE_ENHANCE
	    if (gen_random_int (1, 100) > take_out_percent) {
	    	set_north_wall (maze[x][y]);
	    	set_south_wall (maze[x][y-1]);
	    }
#else
	    set_north_wall (maze[x][y]);
	    set_south_wall (maze[x][y-1]);
#endif
	} else dir[num_dir++] = NORTH;
    }

    switch (num_dir) {
    case 0: return NOT_YET; break;
    case 1: return dir[0]; break;
    case 2:
    case 3: return dir[gen_random_int (0, num_dir-1)]; break;
    default: fprintf (stderr, "rand_door: illegal num_dir = %d\n", num_dir);
	     break;
    }
}


int backtrack ()
{
    idx_moves--;
    x = moves[idx_moves].x;
    y = moves[idx_moves].y;
    return idx_moves;
}


#ifdef MAZE_ENHANCE
void enhance_maze ()
/** make the maze much more difficult to solve **/
{
    /** make doors for all directions in start point **/

    if (X_start != X-1) {
	rm_east_wall (maze[X_start][Y_start]);
	rm_west_wall (maze[X_start+1][Y_start]);
    }

    if (Y_start != Y-1) {
	rm_south_wall (maze[X_start][Y_start]);
	rm_north_wall (maze[X_start][Y_start+1]);
    }

    if (X_start != 0) {
	rm_west_wall (maze[X_start][Y_start]);
	rm_east_wall (maze[X_start-1][Y_start]);
    }

    if (Y_start != 0) {
	rm_north_wall (maze[X_start][Y_start]);
	rm_south_wall (maze[X_start][Y_start-1]);
    }

    /** make doors for all directions in end point **/

    if (X_end != X-1) {
	rm_east_wall (maze[X_end][Y_end]);
	rm_west_wall (maze[X_end+1][Y_end]);
    }

    if (Y_end != Y-1) {
	rm_south_wall (maze[X_end][Y_end]);
	rm_north_wall (maze[X_end][Y_end+1]);
    }

    if (X_end != 0) {
	rm_west_wall (maze[X_end][Y_end]);
	rm_east_wall (maze[X_end-1][Y_end]);
    }

    if (Y_end != 0) {
	rm_north_wall (maze[X_end][Y_end]);
	rm_south_wall (maze[X_end][Y_end-1]);
    }
}
#endif

#define	xform(loc)	(flag ? (loc) : -(loc))

void print_maze (fname, flag)
/** print maze layout in GRAP language **/
    char *fname;
    int flag;
{   int i, j;
    FILE *fp = fopen (fname, "w");

    fprintf (fp, ".G1\nframe invis ht 7i wid 7i\n");

    for (j = 0; j < Y; j++) {
	for (i = 0; i < X; i++) {
	    if (has_east_wall (maze[i][j]))
		fprintf (fp, "line from %d, %d to %d, %d\n",
			i+1, xform (j), i+1, xform (j+1));
	    if (has_south_wall (maze[i][j]))
		fprintf (fp, "line from %d, %d to %d, %d\n",
			i, xform (j+1), i+1, xform (j+1));
	    if (has_west_wall (maze[i][j]))
		fprintf (fp, "line from %d, %d to %d, %d\n",
			i, xform (j), i, xform (j+1));
	    if (has_north_wall (maze[i][j]))
		fprintf (fp, "line from %d, %d to %d, %d\n",
			i, xform (j), i+1, xform (j));
	}
    }

    if (flag) fprintf (fp, ".G2\n");
    fclose (fp);
}
