
node_ *expand (node, child_type, nchildren)
    node_ *node;
    child_ child_type;
    int nchildren;
{   node_ *head = NULL, *child;
    int i;

    /** check for infeasibility **/
    if (node->ndecomp >= 4) return NULL;

    switch (child_type) {
    case ALL_CHILDREN:
	for (i = 0; i < 4; i++)
	    if (child = get_child (node, i)) {
		child->brother = head;
		head = child;
	    }
	break;
    case NEXT_CHILD:
	if (head = get_child (node, node->ndecomp)) head->brother = NULL;
	break;
    case NEXT_N_CHILDREN:
	for (i = 0; i < nchildren; i++) {
	    if (child = get_child (node, node->ndecomp)) {
		child->brother = head;
		head = child;
	    }
	    if (node->ndecomp >= 4) break;
	}
	break;
    default: break;
    }

    return head;
}


node_ *get_child (p, which)
    node_ *p;
    int which;
{   node_ *parentp = p->parent;
    int x = p->x, y = p->y;

    which++;  /** Direction[0] == AntiDirection[0] == NOT_YET **/
    (p->ndecomp)++;
    if (p->entity == AntiDirection[which]) return NULL;
    if (is_movable (p, x, y, Direction[which]) == YES)
	switch (Direction[which]) {
	case EAST:
	    return (allocate_node (p, EAST, x+1, y, p->g_cost+1)); break;
	case SOUTH:
	    return (allocate_node (p, SOUTH, x, y+1, p->g_cost+1)); break;
	case WEST:
	    return (allocate_node (p, WEST, x-1, y, p->g_cost+1)); break;
	case NORTH:
	    return (allocate_node (p, NORTH, x, y-1, p->g_cost+1)); break;
	default:
	    error ("get_child: no such direction"); break;
	}

    return NULL;
}


yesno_ is_movable (p, x, y, dir)
    node_ *p;
    int x, y;
    directn dir;
{
    switch (dir) {
    case EAST:
	if (has_east_wall (maze[x][y])) return NO;
	if (++x >= X) return NO;
	break;
    case SOUTH:
	if (has_south_wall (maze[x][y])) return NO;
	if (++y >= Y) return NO;
	break;
    case WEST:
	if (has_west_wall (maze[x][y])) return NO;
	if (--x < 0) return NO;
	break;
    case NORTH:
	if (has_north_wall (maze[x][y])) return NO;
	if (--y < 0) return NO;
	break;
    default:	error ("is_movable: no such direction"); break;
    }

    /** check whether this point has been visited or not **/
    /** hence, we need DELAY_FREE_NODE compiler definition **/
    while ((p = p->parent))
	if (x == p->x && y == p->y) return NO;

    return YES;
}


int is_infeasible (node)
    node_ *node;
{ return 0; }


int is_feasible (node)
    node_ *node;
{ return ((node->x == X_end && node->y == Y_end) ? 1 : 0); }

