
typedef float decomp_;
decomp_ decomp_h_fun ();
decomp_ dh_val[ProductionRange];
node_ *ch_arr[ProductionRange];


node_ *expand (node, child_type, nchild)
  node_ *node;
  child_ child_type;
  int nchild;
{ int entity = node->entity; 
  int next_entity = node->entity+1;
  domain g_cost = node->g_cost;
  domain i_value = node->i_value;
  domain *o_vals = node->o_values;
  node_ *new_list = NULL;
  node_ *child, *next_child;
  int i, count = 0, who;
  domain w, i_val, cost, val, *ovp;
  decomp_ best;
  
  switch (child_type) {
  case ALL_CHILDREN: nchild = HUGE_INT; break;
  case NEXT_CHILD:   nchild = 1; break;
  default: break;
  }

  /** init **/
  for (i = 0; i < ProductionRange; i++) {
    dh_val[i] = HUGE_FLOAT;
    ch_arr[i] = NULL;
  }

  /** sprout all necessary children **/
  for (val = *o_vals; val >= 0; val = *(++o_vals)) {
    i_val = i_value + (val - rParam[next_entity]);
    cost = g_cost + hParam[next_entity] * i_val;
    if (val) cost += (bParam[next_entity] + val * pParam[next_entity]);
    ch_arr[val] = allocate_node (node, next_entity, val, i_val, cost);
    gen_open_value (ch_arr[val]);
    dh_val[val] = decomp_h_fun (val, i_val, next_entity);
    if (++count >= nchild) break;
  }

  /** update open values, where `node->o_values' won't change **/
  if (val < 0) *(node->o_values) = -1;
  else {
    ovp = ++o_vals;  /** new 1st open value **/
    o_vals = node->o_values;
    while (*ovp >= 0) *(o_vals++) = *(ovp++);
    *o_vals = -1;
  }

  /** sort all these children by decomp heuristic values **/
  while (count-- > 0) {
    best = HUGE_FLOAT;
    who = -1;
    for (val = 0; val < ProductionRange; val++)
      if (best > dh_val[val]) { best = dh_val[val]; who = val; }
    ch_arr[who]->next = new_list;
    new_list = ch_arr[who];
    dh_val[who] = HUGE_FLOAT;
  } 

  /** reverse new_list **/
  next_child = new_list;
  new_list = NULL;
  while ((child = next_child)) {
    next_child = child->next;
    child->next = NULL;
    child->brother = new_list;
    new_list = child;
  }

  return new_list;
}


decomp_ decomp_h_fun (val, i_val, next_entity)
  int val, i_val, next_entity;
{ decomp_ retval;

  retval = (pParam[next_entity] + hParam[next_entity]) * val +
	   (val ? 1 : 0) * bParam[next_entity] +
	   hParam[next_entity] * (i_val - rParam[next_entity]);

  return retval;
}


gen_open_value (node) 
  node_ *node;
{ int k = node->entity + 1, i;
  domain from, to, val, size;

  /* set lower bound to open values */
  if ((from = rParam[k] - node->i_value) < 0) from = 0;

  /* set upper bound to and size of open values */
  size = (to = cParam[k]) - from + 2;

  if (size > 0) {
    /* initialize the space */
    for (i = 0, val = to; val >= from; val--, i++) *(node->o_values + i) = val;
    *(node->o_values + size - 1) = -1;
  }
  else *(node->o_values) = -1;
}


int is_feasible(node) node_ *node; { return (node->entity == problem.size); }
int is_infeasible(node)	node_ *node; { return 0; }
int is_dominated(node) node_ *node; { return 0; }

