domain puzz_eval_lowb (), puzz_eval_upb ();


void evaluate_lower_bound (node)
    node_ *node;
{
#ifdef DEBUG
if (cmd.debug >= 4) printf("eval lowb\n");
#endif

    node->lowb = node->g_cost + (domain) calc_distance (node->locmap);
}


solution_ *evaluate_upper_bound (node, sol)
    node_ *node;
    solution_ *sol;
{   node_ *p;
    int count;
#ifdef DEBUG
if (cmd.debug >= 4) printf("eval upb\n");
#endif

    sol->move = NULL;
    if (is_feasible (node)) {
	node->upb = node->g_cost;

	for (count = 0, p = node; p->entity != -1; p = p->parent) count++;
	sol->move = (char *) malloc ((count+1) * sizeof (char));
	*(sol->move+count) = NOT_USED_DIR;
	for (--count, p = node; p->entity != -1; p = p->parent, --count)
	    *(sol->move+count) = (char) p->entity;
    }
    else node->upb = problem.huge;

    return sol;
}


int calc_distance (locmap)
    int *locmap;
{   int i, d, error = 0, x1, x2, y1, y2;

    for (i = 1; i < LayoutSize2; i++) {
	x1 = get_x (*(GoalLocMap + i));
	y1 = get_y (*(GoalLocMap + i));
	x2 = get_x (*(locmap + i));
	y2 = get_y (*(locmap + i));
	if ((d = x1 - x2) < 0) d = -d;
	error += d;
	if ((d = y1 - y2) < 0) d = -d;
	error += d;
    }
    return error;
}

