
void gen_sample_problem ()
{   int i, j, temp, who, bound;

#ifdef KORF_BENCHMARKS
    static int index = -1000;
    if (index == -1000) index = problem.seed - 101;
#endif

    LayoutSize1 = problem.size;
    LayoutSize2 = LayoutSize1 * LayoutSize1;
    bound = LayoutSize2 - 1;

#if defined (TEST_KORF_BENCHMARKS) && defined (KORF_BENCHMARKS)
    /** test if any typo in Korf's 15-puzzle benchmarks **/
    for (index = 0; index < 100; index++)
	for (i = 0; i < LayoutSize2; i++) {
	    if (Korf[index][i] > 15 && Korf[index][i] < 0)
		printf ("gen: Korf's 15-puzzle benchmark: out of range: index=%d, i=%d\n", index, i);
	    for (j = i+1; j < LayoutSize2; j++)
		if (Korf[index][i] == Korf[index][j])
		    printf ("gen: Korf's 15-puzzle benchmark: duplicate: index=%d, i=%d, j=%d\n", index, i, j);
	}
    printf ("Congratulations: PASSED\n");
    exit (0);
#endif

    /** gen initial loc map of items **/
    InitLocMap = (int *) malloc (sizeof (int) * LayoutSize2);

    if (problem.seed <= 100 || problem.seed > 200 || problem.size != 4) {
	/** my own way to generate problem **/
	for (i = 0; i < LayoutSize2; i++) *(InitLocMap + i) = i;
	for (i = 0; i < bound; i++) {
	    who = gen_random_int (i, bound);
	    temp = *(InitLocMap + i);
	    *(InitLocMap + i) = *(InitLocMap + who);
	    *(InitLocMap + who) = temp;
	}
    } else {
	/** use Korf's 15-puzzle benchmarks in IDA* paper for seed in [101,200] **/
	for (i = 0; i < LayoutSize2; i++) *(InitLocMap + Korf[index][i]) = i;
        index++;
    }

    /** gen goal loc map of items **/
    GoalLocMap = (int *) malloc (sizeof (int) * LayoutSize2);
    for (i = 0; i < LayoutSize2; i++) *(GoalLocMap + i) = i;

    /** gen temp loc map **/
    tempLocMap = (int *) malloc (sizeof (int) * LayoutSize2);

#ifdef DEBUG
if (cmd.debug >= 1) {
    printf ("Initial State:\n");
    for (i = 0; i < LayoutSize2; i++)
	*(tempLocMap + *(InitLocMap + i)) = i;
    for (i = 0; i < LayoutSize2; i++)
	printf (" %d ", *(tempLocMap + i));
    printf ("\nGoal State:\n");
    for (i = 0; i < LayoutSize2; i++)
	*(tempLocMap + *(GoalLocMap + i)) = i;
    for (i = 0; i < LayoutSize2; i++)
	printf (" %d ", *(tempLocMap + i));
    printf ("\n");
}
#endif

    /** PDSD size **/
    set_node_size (LayoutSize2 * sizeof (int));

    /** PUZZ does not supply upper bound **/
    No_Upper_Bound = YES;
}

