
node_ *get_child ();
yesno_ is_movable (), is_same_layout ();
void move_blank (), move_locmap_blank ();


node_ *expand (node, child_type, nchildren)
    node_ *node;
    child_ child_type;
    int nchildren;
{   node_ *head = NULL, *child;
    int i;

    /** check for infeasibility **/
    if (node->ndecomp >= 4) return NULL;

    switch (child_type) {
    case ALL_CHILDREN:
	for (i = 0; i < 4; i++)
	    if (child = get_child (node, i)) {
		child->brother = head;
		head = child;
	    }
	break;
    case NEXT_CHILD:
	if (head = get_child (node, node->ndecomp)) head->brother = NULL;
	break;
    case NEXT_N_CHILDREN:
	for (i = 0; i < nchildren; i++) {
	    if (child = get_child (node, node->ndecomp)) {
		child->brother = head;
		head = child;
	    }
	    if (node->ndecomp >= 4) break;
	}
	break;
    default: break;
    }

    return head;
}


node_ *get_child (node, which)
    node_ *node;
    int which;
{   node_ *parentp = node->parent;

    (node->ndecomp)++;
    if (node->entity == AntiDirection[which]) return NULL;
    if (is_movable (node, Direction[which]) == YES)
	return allocate_node (node, Direction[which], node->g_cost+1);
    return NULL;
}


yesno_ is_movable (node, dir)
    node_ *node;
    int dir;
{   int x = get_x (*(node->locmap));
    int y = get_y (*(node->locmap));
    int i;
    node_ *p;

    switch (dir) {
    case 'N': if (++y >= LayoutSize1)	return NO; break;
    case 'S': if (--y < 0)		return NO; break;
    case 'E': if (++x >= LayoutSize1)	return NO; break;
    case 'W': if (--x < 0)		return NO; break;
    default:  error ("is_movable: no such direction"); break;
    }

    /** check the history **/
    for (i = 0; i < LayoutSize2; i++) *(tempLocMap+i) = *(node->locmap+i);
    move_locmap_blank (tempLocMap, dir);
    for (p = node; p; p = p->parent)
	if (is_same_layout (tempLocMap, p->locmap)) return NO;

    return YES;
}


void move_blank (node, dir)
    node_ *node;
    int dir;
{  
    move_locmap_blank (node->locmap, dir);
}
/**
{   int x = get_x (*(node->locmap)), y = get_y (*(node->locmap));
    int i, where, temp, err_flag = 0;

    switch (dir) {
    case 'N': if (++y >= LayoutSize1)	err_flag = 1; break;
    case 'S': if (--y < 0)		err_flag = 1; break;
    case 'E': if (++x >= LayoutSize1)	err_flag = 1; break;
    case 'W': if (--x < 0)		err_flag = 1; break;
    default:				err_flag = 1; break;
    }
    if (err_flag) error ("is_movable: no such direction");

    where = get_loc (x, y);
    for (i = 0; i < LayoutSize2; i++)
	if (where == *(node->locmap + i)) break;
    if (i == LayoutSize2) error ("move_blank: cannot move");
    temp = *(node->locmap);
    *(node->locmap) = *(node->locmap + i);
    *(node->locmap + i) = temp;
}
**/


void move_locmap_blank (locmap, dir)
    int locmap[];
    int dir;
{   int x = get_x (locmap[0]);
    int y = get_y (locmap[0]);
    int i, where, temp, err_flag = 0;

    switch (dir) {
    case 'N': if (++y >= LayoutSize1)	err_flag = 1; break;
    case 'S': if (--y < 0)		err_flag = 1; break;
    case 'E': if (++x >= LayoutSize1)	err_flag = 1; break;
    case 'W': if (--x < 0)		err_flag = 1; break;
    default:				err_flag = 1; break;
    }
    if (err_flag) error ("is_movable: no such direction");

    where = get_loc (x, y);
    for (i = 0; i < LayoutSize2; i++)
	if (where == locmap[i]) break;
    if (i == LayoutSize2) error ("move_blank: cannot move");
    temp = locmap[0];
    locmap[0] = locmap[i];
    locmap[i] = temp;
}


int is_infeasible (node)
    node_ *node;
{ return 0; }


int is_feasible (node)
    node_ *node;
{ return (is_same_layout (node->locmap, GoalLocMap)); }


yesno_ is_same_layout (locmap1, locmap2)
    int *locmap1, *locmap2;
{   int i;

    for (i = 0; i < LayoutSize2; i++)
	if (*(locmap1 + i) != *(locmap2 + i)) return NO;
    return YES;
}

