
node_ *root_generator () { return allocate_node(NULL, -1, 0, 0); }

void iipd_init() { }

void idpd_init() { }

int is_dominated (node) node_ *node; { return 0; }


node_ *allocate_node (parentp, entity, value, g_cost)
  node_ *parentp;
  int entity;
  domain value, g_cost;
{ node_ *p;
  int k;

  p = get_search_node_from_pool();
  init_node_struct(p, parentp);

  p->entity = entity;
  p->value = value;
  p->g_cost = g_cost;
  p->round = 0;

  /* clean thses value fields */
  p->lowb = p->upb = problem.huge;

  if (parentp)
    for (k = 0; k < R; k++) *(p->rb + k) = *(parentp->rb + k) - REQ[entity][k];
  else
    for (k = 0; k < R; k++) *(p->rb + k) = BOUND[k];
		
  if (parentp) {
    for (k = 0; k < M; k++) *(p->proc + k) = *(parentp->proc + k);
    *(p->proc + value) = 0;
  }
  else
    /* root node has no processor available at time 0,
     * then, next node will refresh all processors and advance time by 1
     */
    for (k = 0; k < M; k++) *(p->proc + k) = 0;

  if (parentp) {
    for (k = 0; k < T; k++) *(p->live_task + k) = *(parentp->live_task + k);
    *(p->live_task + entity) = 0;
  }
  else
    for (k = 0; k < T; k++) *(p->live_task + k) = 1;

  for (k = 0; k < T; k++) *(p->open_task + k) = *(p->live_task + k);

  return p;
}


/* sprout_child, to be more specific, sprouts a right child.
 * 'sprout' means:  copy parent's state to child's,
 *                  except search controls, eg depth, parent link, ...
 */
node_ *sprout_child (node)
  node_ *node;
{ node_ *child;
  int k;

  child = get_search_node_from_pool();
  init_node_struct(child, node);  

  child->entity = node->entity;
  child->value = node->value;
  child->g_cost = node->g_cost;
  child->round = node->round;
  child->lowb = node->lowb;
  child->upb = node->upb;

  for (k = 0; k < R; k++) *(child->rb + k) = *(node->rb + k);
  for (k = 0; k < M; k++) *(child->proc + k) = *(node->proc + k);
  for (k = 0; k < T; k++) *(child->live_task + k) = *(node->live_task + k);
  for (k = 0; k < T; k++) *(child->open_task + k) = *(node->open_task + k);

  return child;
}


/* allocate associates for newly allocated search nodes */
void pd_region ()
{ int offset, *pool, rb_offset, proc_offset, live_offset, open_offset, *a, i;
  node_ *p;
    
  pool = (int *) pool_manager;
  offset = node_conf.node_size / sizeof(int);
  rb_offset = sizeof(node_) / sizeof(int);
  proc_offset = rb_offset + R;
  live_offset = proc_offset + M;
  open_offset = live_offset + T;

  for (i = 0; i < AllocationSize; i++) {
    p = ((node_ *) (a = pool + offset * i));
    p->rb = a + rb_offset;
    p->proc = a + proc_offset;
    p->live_task = a + live_offset;
    p->open_task = a + open_offset;
  }
}


void reset_sol_buf (s)
  solution_ *s;
{ int i;

  for (i = 0; i < problem.size; i++) s->sched[i] = 0;
}


void evaluate_solution (sp)
  search_ *sp;
{ solution_ *sol;
  int i;

  if (sp) sol = sp->incumbent;
  else error("evaulate_solution: internal error: sp is nil");
  printf("\nSOLUTION:\n");
  for (i = 0; i < problem.size; i++)
    printf("%d-th task is scheduled at time  %d\n", i, sol->sched[i]);
}

