#ifndef __VC_define_h__
#define __VC_define_h__

#define MIN_DELTA_TH	1

typedef	int	domain;
#define Domain	INT

#define AllocationSize         256

#define	PDSI_PART \
	int	num_edges;	/** number of edges covered **/  \
	int   	*vertattr;	/** vertex attributes **/

#define	MaxProblemSize		250
#define MaxNumberEdges		(MaxProblemSize * (MaxProblemSize - 1) / 2)

#define LPG_LARGE_CONST		MaxProblemSize

typedef struct { int vertices[MaxProblemSize]; } solution_;
typedef struct { int x, y; } edge;

#define VC_ALIVE	0
#define VC_TAKEN	-1
#define VC_DEAD		-2

#define is_vertex_alive(node,v)		(*(node->vertattr + v) >= 0)
#define is_vertex_taken(node,v)		(*(node->vertattr + v) == VC_TAKEN)
#define is_vertex_dead(node,v)		(*(node->vertattr + v) == VC_DEAD)

#define set_vertex_taken(node,v)	*(node->vertattr + v) = VC_TAKEN
#define set_vertex_dead(node,v)		*(node->vertattr + v) = VC_DEAD

#define set_vertex_degree(node,v,deg)	*(node->vertattr + v) = deg
#define get_vertex_degree(node,v)	(*(node->vertattr + v))


extern int	NumVertices, NumEdges;
extern float	Threshold;
extern int	Adjacency[MaxProblemSize][MaxProblemSize];
extern edge	Edges[MaxNumberEdges];

#endif

