
typedef int decomp_;
decomp_ decomp_h_fun ();
decomp_ dh_val[MaxProblemSize];


node_ *expand (node, child_type, nchild)
    node_ *node;
    child_ child_type;
    int nchild;
{   int entity = node->entity; 
    domain g_cost = node->g_cost;
    node_ *left_child, *right_child;
    int i, who, gen_left, gen_left_only;
    decomp_ best;

    if (node->ndecomp >= 2) return NULL;  /** infeasible **/

    /** binary decomposition (take or not take) **/
    /** decomposition indicates which vertice should be considered first **/
 
    if (child_type == NEXT_N_CHILDREN && nchild == 1)
	child_type = NEXT_CHILD;

    /** check whether the left child needs to be generated or not **/
    gen_left_only = (child_type == NEXT_CHILD && node->ndecomp == 0) ? 1 : 0;
    gen_left = (child_type == ALL_CHILDREN || gen_left_only) ? 1 : 0;

    /** init **/
    for (i = 0; i < NumVertices; i++) dh_val[i] = 0;

    /** consider all live children **/
    for (i = 0; i < NumVertices; i++)
	if (is_vertex_alive (node, i)) dh_val[i] = decomp_h_fun (node, i);

    /** find the best decomposition by decomp heuristic values **/
    best = 0;
    who = -1;
    for (i = 0; i < NumVertices; i++)
	if (best < dh_val[i]) { best = dh_val[i]; who = i; }

    if (who == -1) return NULL;   /** infeasible **/

    if (gen_left) left_child = allocate_node (node, who, g_cost+1);
    if (gen_left_only) { node->ndecomp = 1; return left_child; }

    right_child = get_search_node_from_pool ();
    init_node_struct (right_child, node);
    right_child->entity = node->entity;
    right_child->g_cost = node->g_cost;
    right_child->num_edges = node->num_edges;
    right_child->lowb = node->lowb;
    right_child->upb = node->upb;
    for (i = 0; i < NumVertices; i++)
	*(right_child->vertattr+i) = *(node->vertattr+i);
    set_vertex_dead (right_child, who);

    node->ndecomp = 2;
    if (gen_left) {
	left_child->brother = right_child;
	return left_child;
    }
    else return right_child;
}


decomp_ decomp_h_fun (node, i)
  node_ *node;
  int i; 
{
  return get_vertex_degree (node, i);
}


int is_feasible (node)
    node_ *node;
{ return ((node->num_edges >= NumEdges) ? 1 : 0); }


int is_infeasible (node)
    node_ *node;
{ return 0; }

