
node_ *root_generator ()
{   /** generate a root node with
     ** parent = nil, entity = -1, g_cost = 0 **/
    return (allocate_node (NULL, -1, (domain) 0));
}


void iipd_init () {}
void idpd_init () {}
int is_dominated (node) node_ *node; { return 0; }


node_ *allocate_node (parentp, entity, g_cost)
    node_ *parentp;
    int entity;
    domain g_cost;
{   node_ *p;
    int i, j;
    int check_edge[MaxNumberEdges];

    p = get_search_node_from_pool ();
    init_node_struct (p, parentp);

    p->entity = entity;
    p->g_cost = g_cost;

    /** clean these value fields **/
    p->lowb = - problem.huge;
    p->upb = problem.huge;

    /** troublesome to calc live degree of vertex **/

    /** collect info about which edges are alive **/
    for (i = 0; i < NumEdges; i++) check_edge[i] = VC_ALIVE;
    for (i = 0; i < NumVertices; i++) *(p->vertattr+i) = 0;
    if (parentp)
	for (i = 0; i < NumVertices; i++)
	    if (i == entity || is_vertex_taken (parentp, i)) 
		for (j = 0; j < NumVertices; j++)
		    if (Adjacency[i][j] >= 0)
			check_edge[Adjacency[i][j]] = VC_TAKEN;

    /** calc live degree of all vertices **/
    p->num_edges = NumEdges;
    for (i = 0; i < NumEdges; i++)
	if (check_edge[i] == VC_ALIVE) {
	    --(p->num_edges);
	    (*(p->vertattr + Edges[i].x))++;
	    (*(p->vertattr + Edges[i].y))++;
	}

    /** disable those vertices which are taken or dead **/
    if (parentp) {
	for (i = 0; i < NumVertices; i++) {
	    if (is_vertex_taken (parentp, i)) set_vertex_taken (p, i);
	    else if (is_vertex_dead (parentp, i)) set_vertex_dead (p, i);
        }
	set_vertex_taken (p, entity);
    }

    return p;
}


void pd_region ()
/** allocate associates for newly allocated search nodes **/
{   int offset, *pool, vertattr_offset, *a, i;
    node_ *p;
    
    pool = (int *) pool_manager;
    offset = node_conf.node_size / sizeof (int);
    vertattr_offset = sizeof (node_) / sizeof (int);

    for (i = 0; i < AllocationSize; i++) {
	p = ((node_ *) (a = pool + offset * i));
	/** allocate *vertattr frame **/ 
	p->vertattr = a + vertattr_offset;
    }
}


void reset_sol_buf (s)
    solution_ *s;
{   int i;

    for (i = 0; i < problem.size; i++) s->vertices[i] = 0;
}


void print_conf (fp)
    FILE *fp;
{   int i, j;

    fprintf (fp, "NumVertices=%d, NumEdges=%d, Threshold=%f\n",
	NumVertices, NumEdges, Threshold);
    fprintf (fp, "Adjacency\n");
    for (i = 0; i < NumVertices; i++) {
	for (j = 0; j < NumVertices; j++)
	    fprintf (fp, "%d, ", Adjacency[i][j]);
	fprintf (fp, "\n");
    }
    fprintf (fp, "Edges\n");
    for (i = 0; i < NumEdges; i++)
	fprintf (fp, "E[%d]: x=%d, y=%d\n", i, Edges[i].x, Edges[i].y);
}


void evaluate_solution (sp)
    search_ *sp;
{   solution_ *sol;
    int i, count = 0;

#ifdef DEBUG
if (cmd.debug >= 5)
    print_conf (stdout);
#endif
    if (sp) sol = sp->incumbent;
    else error ("evaulate_solution: internal error: sp is nil");
    printf ("\nSOLUTION:\n");
    for (i = 0; i < problem.size; i++)
	if (sol->vertices[i]) {
	    printf ("%d-th vertex is selected\n", i);
	    count++;
	}
    printf ("solution value = %d\n", count);
}

