
domain grcs_eval_lowb (), grcs_eval_upb ();
domain p_ck[MaxProblemSize]; 


void evaluate_lower_bound (node)
  node_ *node;
{
#ifdef DEBUG
if (cmd.debug >= 4) printf("eval lowb\n");
#endif

  node->lowb = is_feasible (node) ? node->g_cost : grcs_eval_lowb (node);
}


domain grcs_eval_lowb (node)
  node_ *node;
{ domain lowb = node->g_cost;
  domain min_t = huge_float;
  float min_w = huge_float;
  int i, j, who;
  domain alloc_proc ();

  for (i = 0; i < nProcessors; i++) p_ck[i] = *(node->proc_ck+i);

  for (i = 0; i < nTasks; i++)
    if (is_task_alive (node, i))
      if (min_w > Weight[i]) min_w = Weight[i];

  for (i = 0; i < nTasks; i++)
    if (is_task_alive (node, i)) {
      min_t = alloc_proc (p_ck, &who); 
      p_ck[who] += execTime[i];
      lowb += (p_ck[who] * min_w);
    }

  return lowb;
}


solution_ *evaluate_upper_bound (node, sol)
  node_ *node;
  solution_ *sol;
{ 
#ifdef DEBUG
if (cmd.debug >= 4) printf("eval upb\n");
#endif

  node->upb = is_feasible (node) ? node->g_cost : grcs_eval_upb (node, sol);

  return sol;
}


domain grcs_eval_upb (node, sol)
  node_ *node;
  solution_ *sol;
{ domain upb = node->g_cost;
  domain min_t = huge_float;
  float min_w = huge_float;
  int i, j, who;
  domain alloc_proc ();

  for (i = 0; i < nProcessors; i++) p_ck[i] = *(node->proc_ck+i);

  for (i = 0; i < nTasks; i++)
    if (is_task_sched (node, i)) sol->schedTime[i] = get_task_time (node, i);

  for (i = 0; i < nTasks; i++) {
    j = sortTask[i];
    if (is_task_alive (node, j)) {
      min_t = alloc_proc (p_ck, &who); 
      sol->schedTime[j] = min_t;
      p_ck[who] += execTime[j];
      upb += (p_ck[who] * Weight[j]);
    }
  }

  return upb;
}


domain alloc_proc (p_ck_arr, whop)
  domain p_ck_arr[];
  int *whop;
{ domain tmin;
  int i;

  *whop = 0;
  tmin = p_ck_arr[0];
  for (i = 1; i < nProcessors; i++)
    if (tmin > p_ck_arr[i]) {
      tmin = p_ck_arr[i];
      *whop = i;
    }

  return tmin;
}

